<?php
/** 
Plugin Name: Echo RSS Feed Post Generator Free Version
Plugin URI: http://codecanyon.net/user/coderevolution/portfolio
Description: This plugin will generate content for you, even in your sleep using RSS feeds. This is a free version of the plugin.
Author: CodeRevolution
Version: 1.0.0
Author URI: https://codecanyon.net/user/coderevolution
License: Commercial. For personal use only. Not to give away or resell.
Text Domain: rss-feed-post-generator-echo
*/
/*  
Copyright 2016 - 2017 CodeRevolution
*/
defined('ABSPATH') or die();
use \Eventviva\ImageResize;
add_action('admin_menu', 'rfpge_register_my_custom_menu_page');
add_action('network_admin_menu', 'rfpge_register_my_custom_menu_page');
function rfpge_register_my_custom_menu_page()
{
    add_menu_page('Echo RSS Feed Post Generator Lite', 'Echo RSS Feed Post Generator Lite', 'manage_options', 'rfpge_admin_settings', 'rfpge_admin_settings', plugins_url('images/icon.png', __FILE__));
    add_submenu_page('rfpge_admin_settings', 'Main Settings', 'Main Settings', 'manage_options', 'rfpge_admin_settings');
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if (isset($echo_Main_Settings['rfpge_enabled']) && $echo_Main_Settings['rfpge_enabled'] == 'on') {
        add_submenu_page('rfpge_admin_settings', 'RSS to Post Rules', 'RSS to Post Rules', 'manage_options', 'rfpge_items_panel', 'rfpge_items_panel');
        add_submenu_page('rfpge_admin_settings', 'Post to RSS Rules', 'Post to RSS Rules', 'manage_options', 'rfpge_rss_generator', 'rfpge_rss_generator');
        add_submenu_page('rfpge_admin_settings', 'Crawling Helper', 'Crawling Helper', 'manage_options', 'rfpge_helper', 'rfpge_helper');
        add_submenu_page('rfpge_admin_settings', 'Activity & Logging', 'Activity & Logging', 'manage_options', 'rfpge_logs', 'rfpge_logs');
    }
}
function rfpge_check_activate( $network_wide ) {
    if (version_compare(phpversion(), '5.2', '<')) {
        echo '<h3>'.__('Please update your PHP version to version 5.2 or greater. Right now you have PHP ' . phpversion(), 'ap').'</h3>';
        @trigger_error(__('Please update your PHP version to version 5.2 or greater. Right now you have PHP ' . phpversion(), 'ap'), E_USER_ERROR);
    }
}
register_activation_hook(__FILE__, 'rfpge_check_activate');
add_action('init', 'rfpge_customRSS');
function rfpge_customRSS(){
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if (isset($echo_Main_Settings['rfpge_enabled']) && $echo_Main_Settings['rfpge_enabled'] == 'on') {
        if (!get_option('rfpge_RSS_Settings')) {
            $rules = array();
        } else {
            $rules = get_option('rfpge_RSS_Settings');
        }
        if (!empty($rules)) {
            $cont = 0;
            foreach ($rules as $request => $bundle[]) {
                $bundle_values   = array_values($bundle);
                $myValues        = $bundle_values[$cont];
                $array_my_values = array_values($myValues);
                $feed_name        = isset($array_my_values[0]) ? $array_my_values[0] : '';
                add_feed($feed_name,function() use ($feed_name)
                {
                    rfpge_customRSSFunc($feed_name);
                }
                );
                $cont = $cont + 1;
            }
        }
    }
}
function rfpge_isSecure() {
  return
    (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off')
    || $_SERVER['SERVER_PORT'] == 443;
}
function rfpge_rss_content_type( $content_type, $type ) {
    if (!get_option('rfpge_RSS_Settings')) {
        $rules = array();
    } else {
        $rules = get_option('rfpge_RSS_Settings');
    }
    if (!empty($rules)) {
        $cont = 0;
        foreach ($rules as $request => $bundle[]) {
            $bundle_values   = array_values($bundle);
            $myValues        = $bundle_values[$cont];
            $array_my_values = array_values($myValues);
            $feed_name        = isset($array_my_values[0]) ? $array_my_values[0] : '';
            if ( $feed_name === $type ) {
                return feed_content_type('rss2');
            }
            $cont = $cont + 1;
        }
    }
    return $content_type;
}
add_filter( 'feed_content_type', 'rfpge_rss_content_type', 10, 2 );

function rfpge_rss_post_thumbnail($content) {
    global $post;
    if(has_post_thumbnail($post->ID)) {
        $content = '<p>' . get_the_post_thumbnail($post->ID) . '</p>' . $content;
    }
    return $content;
}
add_filter('the_excerpt_rss', 'rfpge_rss_post_thumbnail');
add_filter('the_content_feed', 'rfpge_rss_post_thumbnail');

function rfpge_customRSSFunc($query_feed_name){
    if (!get_option('rfpge_RSS_Settings')) {
        $rules = array();
    } else {
        $rules = get_option('rfpge_RSS_Settings');
    }
    $feed_name = '';
    $postCount = '';
    $full_content = '';
    $update_period = '';
    $feed_query = '';
    
    if (!empty($rules)) {
        $cont = 0;
        foreach ($rules as $request => $bundle[]) {
            $bundle_values   = array_values($bundle);
            $myValues        = $bundle_values[$cont];
            $array_my_values = array_values($myValues);
            $temp_name       = isset($array_my_values[0]) ? $array_my_values[0] : '';
            if($temp_name == $query_feed_name)
            {
                $feed_name = $temp_name;
                $postCount = isset($array_my_values[1]) ? $array_my_values[1] : '';
                $full_content = isset($array_my_values[2]) ? $array_my_values[2] : '';
                $update_period = isset($array_my_values[3]) ? $array_my_values[3] : '';
                $feed_query = isset($array_my_values[4]) ? $array_my_values[4] : '';
                break; 
            }
            $cont = $cont + 1; 
        }
    }
    else
    {
        return;
    }
    
    if($feed_name == '')
    {
        return;
    }
    if($feed_query != '' && substr($feed_query, 0, 1) !== "&")
    {
        $feed_query = '&' . $feed_query;
    }
$posts = query_posts('showposts=' . $postCount . $feed_query);
header('Content-Type: '.feed_content_type('rss-http').'; charset='.get_option('blog_charset'), true);
echo '<?xml version="1.0" encoding="'.get_option('blog_charset').'"?'.'>';
?>
<rss version="2.0"
        xmlns:content="http://purl.org/rss/1.0/modules/content/"
        xmlns:wfw="http://wellformedweb.org/CommentAPI/"
        xmlns:dc="http://purl.org/dc/elements/1.1/"
        xmlns:atom="http://www.w3.org/2005/Atom"
        xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
        xmlns:slash="http://purl.org/rss/1.0/modules/slash/"
        <?php do_action('rss2_ns'); ?>>
<channel>
        <title><?php bloginfo_rss('name'); ?> - Feed</title>
        <atom:link href="<?php self_link(); ?>" rel="self" type="application/rss+xml" />
        <link><?php bloginfo_rss('url') ?></link>
        <description><?php bloginfo_rss('description') ?></description>
<?php
$last_date = get_lastpostmodified('GMT');
if(!empty($last_date))
{
?>
        <lastBuildDate><?php echo mysql2date('D, d M Y H:i:s +0000', $last_date, false);?></lastBuildDate>
<?php
}
if(!get_option('rss_language'))
{
    $lang = 'en';
    update_option('rss_language', $lang);
}
else
{
    $lang = get_option('rss_language');
}
?>
        <language><?php echo $lang; ?></language>
        <sy:updatePeriod><?php echo apply_filters( 'rss_update_period', $update_period ); ?></sy:updatePeriod>
        <sy:updateFrequency><?php echo apply_filters( 'rss_update_frequency', '1' ); ?></sy:updateFrequency>
        <?php do_action('rss2_head'); ?>
        <?php while(have_posts()) : the_post(); ?>
                <item>
                        <title><?php the_title_rss(); ?></title>
                        <link><?php the_permalink_rss(); ?></link>
<?php
$post_pubdate = get_post_time('Y-m-d H:i:s', true);
$timex = strtotime($post_pubdate);
if(!empty($post_pubdate) && $timex !== false && $timex > 0)
{
?>
                        <pubDate><?php echo mysql2date('D, d M Y H:i:s +0000', $post_pubdate, false);?></pubDate>
<?php
}
?>
                        <dc:creator><?php the_author(); ?></dc:creator>
                        <guid isPermaLink="false"><?php the_guid(); ?></guid>
                        <description><![CDATA[<?php the_excerpt_rss() ?>]]></description>
<?php
if($full_content == '1')
{
?>
                        <content:encoded><![CDATA[<?php the_content_feed() ?>]]></content:encoded>
<?php
}
else
{
?>
                        <content:encoded><![CDATA[<?php the_excerpt_rss() ?>]]></content:encoded>
<?php
}
?>
                        <?php rss_enclosure(); ?>
                        <?php do_action('rss2_item'); ?>
                </item>
        <?php endwhile; ?>
</channel>
</rss>
<?php
}

$plugin = plugin_basename(__FILE__);
add_filter("plugin_action_links_$plugin", 'rfpge_add_settings_link');
function rfpge_add_settings_link($links)
{
    $settings_link = '<a href="admin.php?page=rfpge_admin_settings">' . __('Settings') . '</a>';
    array_push($links, $settings_link);
    return $links;
}
add_action('add_meta_boxes', 'rfpge_add_meta_box');
function rfpge_add_meta_box()
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if (isset($echo_Main_Settings['rfpge_enabled']) && $echo_Main_Settings['rfpge_enabled'] === 'on') {
        if (isset($echo_Main_Settings['enable_metabox']) && $echo_Main_Settings['enable_metabox'] == 'on') {
            add_meta_box('rfpge_meta_box_function_add', 'Echo Auto Generated Post Information', 'rfpge_meta_box_function', 'post', 'advanced', 'default');
            add_meta_box('rfpge_meta_box_function_add', 'Echo Auto Generated Post Information', 'rfpge_meta_box_function', 'page', 'advanced', 'default');
        }
    }
}
add_filter('post_link','rfpge_permalink_changer');

function rfpge_permalink_changer($link){
	global $post;	 
	if (!empty($post->ID)) {
		$url = get_post_meta($post->ID, 'rfpge_change_title_link', true);
        $new_url = get_post_meta($post->ID, 'rfpge_post_url', true);
		if ( trim($url) == '1' && trim($new_url) != '') {
			return $new_url;	
		}
	}
	return $link;
}
function rfpge_builtin_spin_text($title, $content)
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    $titleSeparator         = '[19459000]';
    $text                   = $title . $titleSeparator . $content;
    $text                   = html_entity_decode($text);
    preg_match_all("/<[^<>]+>/is", $text, $matches, PREG_PATTERN_ORDER);
    $htmlfounds         = array_filter(array_unique($matches[0]));
    $htmlfounds[]       = '&quot;';
    $imgFoundsSeparated = array();
    foreach ($htmlfounds as $key => $currentFound) {
        if (stristr($currentFound, '<img') && stristr($currentFound, 'alt')) {
            $altSeparator   = '';
            $colonSeparator = '';
            if (stristr($currentFound, 'alt="')) {
                $altSeparator   = 'alt="';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt = "')) {
                $altSeparator   = 'alt = "';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt ="')) {
                $altSeparator   = 'alt ="';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt= "')) {
                $altSeparator   = 'alt= "';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt=\'')) {
                $altSeparator   = 'alt=\'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt = \'')) {
                $altSeparator   = 'alt = \'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt= \'')) {
                $altSeparator   = 'alt= \'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt =\'')) {
                $altSeparator   = 'alt =\'';
                $colonSeparator = '\'';
            }
            if (trim($altSeparator) != '') {
                $currentFoundParts = explode($altSeparator, $currentFound);
                $preAlt            = $currentFoundParts[1];
                $preAltParts       = explode($colonSeparator, $preAlt);
                $altText           = $preAltParts[0];
                if (trim($altText) != '') {
                    unset($preAltParts[0]);
                    $imgFoundsSeparated[] = $currentFoundParts[0] . $altSeparator;
                    $imgFoundsSeparated[] = $colonSeparator . implode('', $preAltParts);
                    $htmlfounds[$key]     = '';
                }
            }
        }
    }
    if (count($imgFoundsSeparated) != 0) {
        $htmlfounds = array_merge($htmlfounds, $imgFoundsSeparated);
    }
    preg_match_all("/<\!--.*?-->/is", $text, $matches2, PREG_PATTERN_ORDER);
    $newhtmlfounds = $matches2[0];
    preg_match_all("/\[.*?\]/is", $text, $matches3, PREG_PATTERN_ORDER);
    $shortcodesfounds = $matches3[0];
    $htmlfounds       = array_merge($htmlfounds, $newhtmlfounds, $shortcodesfounds);
    $in               = 0;
    $cleanHtmlFounds  = array();
    foreach ($htmlfounds as $htmlfound) {
        if ($htmlfound == '[19459000]') {
        } elseif (trim($htmlfound) == '') {
        } else {
            $cleanHtmlFounds[] = $htmlfound;
        }
    }
    $htmlfounds = $cleanHtmlFounds;
    $start      = 19459001;
    foreach ($htmlfounds as $htmlfound) {
        $text = str_replace($htmlfound, '[' . $start . ']', $text);
        $start++;
    }
    $no_spin_words = array();
    if (isset($echo_Main_Settings['no_spin']) && $echo_Main_Settings['no_spin'] != '') {
        $no_spin_words = explode(',', $echo_Main_Settings['no_spin']);
        $no_spin_words = array_map('trim',$no_spin_words);
    }
    try {
        $file=file(dirname(__FILE__)  .'/res/synonyms.dat');
		foreach($file as $line){
			$synonyms=explode('|', $line);
			foreach($synonyms as $word){
				if(trim($word) != '' && !in_array($word, $no_spin_words)){
                    $word=str_replace('/','\/',$word);
					if(preg_match('/\b'. $word .'\b/u', $text)) {
						$rand = array_rand($synonyms, 1);
						$text = preg_replace('/\b'.$word.'\b/u', trim($synonyms[$rand]), $text);
					}
                    $uword=ucfirst($word);
					if(preg_match('/\b'. $uword .'\b/u', $text)) {
						$rand = array_rand($synonyms, 1);
						$text = preg_replace('/\b'.$uword.'\b/u', ucfirst(trim($synonyms[$rand])), $text);
					}
				}
			}
		}
        $translated = $text;
    }
    catch (Exception $e) {
        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
            rfpge_log_to_file('Exception thrown in spinText ' . $e);
        }
        return false;
    }
    preg_match_all('{\[.*?\]}', $translated, $brackets);
    $brackets = $brackets[0];
    $brackets = array_unique($brackets);
    foreach ($brackets as $bracket) {
        if (stristr($bracket, '19')) {
            $corrrect_bracket = str_replace(' ', '', $bracket);
            $corrrect_bracket = str_replace('.', '', $corrrect_bracket);
            $corrrect_bracket = str_replace(',', '', $corrrect_bracket);
            $translated       = str_replace($bracket, $corrrect_bracket, $translated);
        }
    }
    if (stristr($translated, $titleSeparator)) {
        $start = 19459001;
        foreach ($htmlfounds as $htmlfound) {
            $translated = str_replace('[' . $start . ']', $htmlfound, $translated);
            $start++;
        }
        $contents = explode($titleSeparator, $translated);
        $title    = $contents[0];
        $content  = $contents[1];
    } else {
        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
            rfpge_log_to_file('Failed to parse spinned content, separator not found');
        }
        return false;
    }
    return array(
        $title,
        $content
    );
}

function rfpge_debug_to_console($data)
{
    if (is_array($data))
        $output = "<script>console.log( 'Debug Objects: " . implode(',', $data) . "' );</script>";
    else
        $output = "<script>console.log( 'Debug Objects: " . $data . "' );</script>";
    
    echo $output;
}
add_filter('cron_schedules', 'rfpge_add_cron_schedule');
function rfpge_add_cron_schedule($schedules)
{
    $schedules['rfpge_cron'] = array(
        'interval' => 3600,
        'display' => __('Echo Cron')
    );
    $schedules['minutely'] = array(
        'interval' => 60,
        'display' => __('Once A Minute')
    );
    $schedules['weekly']    = array(
        'interval' => 604800,
        'display' => __('Once Weekly')
    );
    $schedules['monthly']   = array(
        'interval' => 2592000,
        'display' => __('Once Monthly')
    );
    return $schedules;
}
function rfpge_auto_clear_log()
{
    if (file_exists(WP_CONTENT_DIR . '/rfpge_info.log')) {
        unlink(WP_CONTENT_DIR . '/rfpge_info.log');
    }
}

add_shortcode( 'echo-display-posts', 'rfpge_display_posts_shortcode' );
function rfpge_display_posts_shortcode( $atts ) {
	$original_atts = $atts;
	$atts = shortcode_atts( array(
		'author'               => '',
		'category'             => '',
		'category_display'     => '',
		'category_label'       => 'Posted in: ',
		'content_class'        => 'content',
		'date_format'          => '(n/j/Y)',
		'date'                 => '',
		'date_column'          => 'post_date',
		'date_compare'         => '=',
		'date_query_before'    => '',
		'date_query_after'     => '',
		'date_query_column'    => '',
		'date_query_compare'   => '',
		'display_posts_off'    => false,
		'excerpt_length'       => false,
		'excerpt_more'         => false,
		'excerpt_more_link'    => false,
		'exclude_current'      => false,
		'id'                   => false,
		'ignore_sticky_posts'  => false,
		'image_size'           => false,
		'include_author'       => false,
		'include_content'      => false,
		'include_date'         => false,
		'include_excerpt'      => false,
		'include_link'         => true,
		'include_title'        => true,
		'meta_key'             => '',
		'meta_value'           => '',
		'no_posts_message'     => '',
		'offset'               => 0,
		'order'                => 'DESC',
		'orderby'              => 'date',
		'post_parent'          => false,
		'post_status'          => 'publish',
		'post_type'            => 'post',
		'posts_per_page'       => '10',
		'tag'                  => '',
		'tax_operator'         => 'IN',
		'tax_include_children' => true,
		'tax_term'             => false,
		'taxonomy'             => false,
		'time'                 => '',
		'title'                => '',
        'title_color'          => '#000000',
        'excerpt_color'        => '#000000',
        'link_to_source'       => '',
        'title_font_size'      => '100%',
        'excerpt_font_size'    => '100%',
        'read_more_text'       => '',
		'wrapper'              => 'ul',
		'wrapper_class'        => 'display-posts-listing',
		'wrapper_id'           => false,
        'ruleid'               => ''
	), $atts, 'display-posts' );
	if( $atts['display_posts_off'] )
		return;
	$author               = sanitize_text_field( $atts['author'] );
    $ruleid               = sanitize_text_field( $atts['ruleid'] );
	$category             = sanitize_text_field( $atts['category'] );
	$category_display     = 'true' == $atts['category_display'] ? 'category' : sanitize_text_field( $atts['category_display'] );
	$category_label       = sanitize_text_field( $atts['category_label'] );
	$content_class        = array_map( 'sanitize_html_class', ( explode( ' ', $atts['content_class'] ) ) );
	$date_format          = sanitize_text_field( $atts['date_format'] );
	$date                 = sanitize_text_field( $atts['date'] );
	$date_column          = sanitize_text_field( $atts['date_column'] );
	$date_compare         = sanitize_text_field( $atts['date_compare'] );
	$date_query_before    = sanitize_text_field( $atts['date_query_before'] );
	$date_query_after     = sanitize_text_field( $atts['date_query_after'] );
	$date_query_column    = sanitize_text_field( $atts['date_query_column'] );
	$date_query_compare   = sanitize_text_field( $atts['date_query_compare'] );
	$excerpt_length       = intval( $atts['excerpt_length'] );
	$excerpt_more         = sanitize_text_field( $atts['excerpt_more'] );
	$excerpt_more_link    = filter_var( $atts['excerpt_more_link'], FILTER_VALIDATE_BOOLEAN );
	$exclude_current      = filter_var( $atts['exclude_current'], FILTER_VALIDATE_BOOLEAN );
	$id                   = $atts['id'];
	$ignore_sticky_posts  = filter_var( $atts['ignore_sticky_posts'], FILTER_VALIDATE_BOOLEAN );
	$image_size           = sanitize_key( $atts['image_size'] );
	$include_title        = filter_var( $atts['include_title'], FILTER_VALIDATE_BOOLEAN );
	$include_author       = filter_var( $atts['include_author'], FILTER_VALIDATE_BOOLEAN );
	$include_content      = filter_var( $atts['include_content'], FILTER_VALIDATE_BOOLEAN );
	$include_date         = filter_var( $atts['include_date'], FILTER_VALIDATE_BOOLEAN );
	$include_excerpt      = filter_var( $atts['include_excerpt'], FILTER_VALIDATE_BOOLEAN );
	$include_link         = filter_var( $atts['include_link'], FILTER_VALIDATE_BOOLEAN );
	$meta_key             = sanitize_text_field( $atts['meta_key'] );
	$meta_value           = sanitize_text_field( $atts['meta_value'] );
	$no_posts_message     = sanitize_text_field( $atts['no_posts_message'] );
	$offset               = intval( $atts['offset'] );
	$order                = sanitize_key( $atts['order'] );
	$orderby              = sanitize_key( $atts['orderby'] );
	$post_parent          = $atts['post_parent'];
	$post_status          = $atts['post_status'];
	$post_type            = sanitize_text_field( $atts['post_type'] );
	$posts_per_page       = intval( $atts['posts_per_page'] );
	$tag                  = sanitize_text_field( $atts['tag'] );
	$tax_operator         = $atts['tax_operator'];
	$tax_include_children = filter_var( $atts['tax_include_children'], FILTER_VALIDATE_BOOLEAN );
	$tax_term             = sanitize_text_field( $atts['tax_term'] );
	$taxonomy             = sanitize_key( $atts['taxonomy'] );
	$time                 = sanitize_text_field( $atts['time'] );
	$shortcode_title      = sanitize_text_field( $atts['title'] );
    $title_color          = sanitize_text_field( $atts['title_color'] );
    $excerpt_color        = sanitize_text_field( $atts['excerpt_color'] );
    $link_to_source       = sanitize_text_field( $atts['link_to_source'] );
    $excerpt_font_size    = sanitize_text_field( $atts['excerpt_font_size'] );
    $title_font_size      = sanitize_text_field( $atts['title_font_size'] );
    $read_more_text       = sanitize_text_field( $atts['read_more_text'] );
	$wrapper              = sanitize_text_field( $atts['wrapper'] );
	$wrapper_class        = array_map( 'sanitize_html_class', ( explode( ' ', $atts['wrapper_class'] ) ) );
	if( !empty( $wrapper_class ) )
		$wrapper_class = ' class="' . implode( ' ', $wrapper_class ) . '"';
	$wrapper_id = sanitize_html_class( $atts['wrapper_id'] );
	if( !empty( $wrapper_id ) )
		$wrapper_id = ' id="' . $wrapper_id . '"';
	$args = array(
		'category_name'       => $category,
		'order'               => $order,
		'orderby'             => $orderby,
		'post_type'           => explode( ',', $post_type ),
		'posts_per_page'      => $posts_per_page,
		'tag'                 => $tag,
	);
	if ( ! empty( $date ) || ! empty( $time ) || ! empty( $date_query_after ) || ! empty( $date_query_before ) ) {
		$initial_date_query = $date_query_top_lvl = array();
		$valid_date_columns = array(
			'post_date', 'post_date_gmt', 'post_modified', 'post_modified_gmt',
			'comment_date', 'comment_date_gmt'
		);
		$valid_compare_ops = array( '=', '!=', '>', '>=', '<', '<=', 'IN', 'NOT IN', 'BETWEEN', 'NOT BETWEEN' );
		$dates = rfpge_sanitize_date_time( $date );
		if ( ! empty( $dates ) ) {
			if ( is_string( $dates ) ) {
				$timestamp = strtotime( $dates );
				$dates = array(
					'year'   => date( 'Y', $timestamp ),
					'month'  => date( 'm', $timestamp ),
					'day'    => date( 'd', $timestamp ),
				);
			}
			foreach ( $dates as $arg => $segment ) {
				$initial_date_query[ $arg ] = $segment;
			}
		}
		$times = rfpge_sanitize_date_time( $time, 'time' );
		if ( ! empty( $times ) ) {
			foreach ( $times as $arg => $segment ) {
				$initial_date_query[ $arg ] = $segment;
			}
		}
		$before = rfpge_sanitize_date_time( $date_query_before, 'date', true );
		if ( ! empty( $before ) ) {
			$initial_date_query['before'] = $before;
		}
		$after = rfpge_sanitize_date_time( $date_query_after, 'date', true );
		if ( ! empty( $after ) ) {
			$initial_date_query['after'] = $after;
		}
		if ( ! empty( $date_query_column ) && in_array( $date_query_column, $valid_date_columns ) ) {
			$initial_date_query['column'] = $date_query_column;
		}
		if ( ! empty( $date_query_compare ) && in_array( $date_query_compare, $valid_compare_ops ) ) {
			$initial_date_query['compare'] = $date_query_compare;
		}
		if ( ! empty( $date_column ) && in_array( $date_column, $valid_date_columns ) ) {
			$date_query_top_lvl['column'] = $date_column;
		}
		if ( ! empty( $date_compare ) && in_array( $date_compare, $valid_compare_ops ) ) {
			$date_query_top_lvl['compare'] = $date_compare;
		}
		if ( ! empty( $initial_date_query ) ) {
			$date_query_top_lvl[] = $initial_date_query;
		}
		$args['date_query'] = $date_query_top_lvl;
	}
    $args['meta_key'] = 'rfpge_parent_rule';
    if($ruleid != '')
    {
        $args['meta_value'] = $ruleid;
    }
	if( $ignore_sticky_posts )
		$args['ignore_sticky_posts'] = true;
	/*if( !empty( $meta_key ) )
		$args['meta_key'] = $meta_key;
	if( !empty( $meta_value ) )
		$args['meta_value'] = $meta_value;*/
	if( $id ) {
		$posts_in = array_map( 'intval', explode( ',', $id ) );
		$args['post__in'] = $posts_in;
	}
	if( is_singular() && $exclude_current )
		$args['post__not_in'] = array( get_the_ID() );
	if( !empty( $author ) ) {
		if( 'current' == $author && is_user_logged_in() )
			$args['author_name'] = wp_get_current_user()->user_login;
		elseif( 'current' == $author )
            $unrelevar = false;
			//$args['meta_key'] = 'dps_no_results';
		else
			$args['author_name'] = $author;
	}
	if( !empty( $offset ) )
		$args['offset'] = $offset;
	$post_status = explode( ', ', $post_status );
	$validated = array();
	$available = array( 'publish', 'pending', 'draft', 'auto-draft', 'future', 'private', 'inherit', 'trash', 'any' );
	foreach ( $post_status as $unvalidated )
		if ( in_array( $unvalidated, $available ) )
			$validated[] = $unvalidated;
	if( !empty( $validated ) )
		$args['post_status'] = $validated;
	if ( !empty( $taxonomy ) && !empty( $tax_term ) ) {
		if( 'current' == $tax_term ) {
			global $post;
			$terms = wp_get_post_terms(get_the_ID(), $taxonomy);
			$tax_term = array();
			foreach ($terms as $term) {
				$tax_term[] = $term->slug;
			}
		}else{
			$tax_term = explode( ', ', $tax_term );
		}
		if( !in_array( $tax_operator, array( 'IN', 'NOT IN', 'AND' ) ) )
			$tax_operator = 'IN';
		$tax_args = array(
			'tax_query' => array(
				array(
					'taxonomy'         => $taxonomy,
					'field'            => 'slug',
					'terms'            => $tax_term,
					'operator'         => $tax_operator,
					'include_children' => $tax_include_children,
				)
			)
		);
		$count = 2;
		$more_tax_queries = false;
		while(
			isset( $original_atts['taxonomy_' . $count] ) && !empty( $original_atts['taxonomy_' . $count] ) &&
			isset( $original_atts['tax_' . $count . '_term'] ) && !empty( $original_atts['tax_' . $count . '_term'] )
		):
			$more_tax_queries = true;
			$taxonomy = sanitize_key( $original_atts['taxonomy_' . $count] );
	 		$terms = explode( ', ', sanitize_text_field( $original_atts['tax_' . $count . '_term'] ) );
	 		$tax_operator = isset( $original_atts['tax_' . $count . '_operator'] ) ? $original_atts['tax_' . $count . '_operator'] : 'IN';
	 		$tax_operator = in_array( $tax_operator, array( 'IN', 'NOT IN', 'AND' ) ) ? $tax_operator : 'IN';
	 		$tax_include_children = isset( $original_atts['tax_' . $count . '_include_children'] ) ? filter_var( $atts['tax_' . $count . '_include_children'], FILTER_VALIDATE_BOOLEAN ) : true;
	 		$tax_args['tax_query'][] = array(
	 			'taxonomy'         => $taxonomy,
	 			'field'            => 'slug',
	 			'terms'            => $terms,
	 			'operator'         => $tax_operator,
	 			'include_children' => $tax_include_children,
	 		);
			$count++;
		endwhile;
		if( $more_tax_queries ):
			$tax_relation = 'AND';
			if( isset( $original_atts['tax_relation'] ) && in_array( $original_atts['tax_relation'], array( 'AND', 'OR' ) ) )
				$tax_relation = $original_atts['tax_relation'];
			$args['tax_query']['relation'] = $tax_relation;
		endif;
		$args = array_merge_recursive( $args, $tax_args );
	}
	if( $post_parent !== false ) {
		if( 'current' == $post_parent ) {
			global $post;
			$post_parent = get_the_ID();
		}
		$args['post_parent'] = intval( $post_parent );
	}
	$wrapper_options = array( 'ul', 'ol', 'div' );
	if( ! in_array( $wrapper, $wrapper_options ) )
		$wrapper = 'ul';
	$inner_wrapper = 'div' == $wrapper ? 'div' : 'li';
	$listing = new WP_Query( apply_filters( 'display_posts_shortcode_args', $args, $original_atts ) );
	if ( ! $listing->have_posts() ) {
		return apply_filters( 'display_posts_shortcode_no_results', wpautop( $no_posts_message ) );
	}
	$inner = '';
    wp_suspend_cache_addition(true);
	while ( $listing->have_posts() ): $listing->the_post(); global $post;
		$image = $date = $author = $excerpt = $content = '';
		if ( $include_title && $include_link ) {
            if($link_to_source == 'yes')
            {
                $source_url = get_post_meta($post->ID, 'rfpge_post_url', true);
                if($source_url != '')
                {
                    $title = '<a class="rfpge_display_title" href="' . $source_url . '"><span style="font-size:' . $title_font_size . ';color:' . $title_color . ' !important;" >' . get_the_title() . '</span></a>';
                }
                else
                {
                    $title = '<a class="rfpge_display_title" href="' . apply_filters( 'the_permalink', get_permalink() ) . '"><span style="font-size:' . $title_font_size . ';color:' . $title_color . ' !important;" >' . get_the_title() . '</span></a>';
                }
            }
            else
            {
                $title = '<a class="rfpge_display_title" href="' . apply_filters( 'the_permalink', get_permalink() ) . '"><span style="font-size:' . $title_font_size . ';color:' . $title_color . ' !important;" >' . get_the_title() . '</span></a>';
            }
		} elseif( $include_title ) {
			$title = '<span class="rfpge_display_title" style="font-size:' . $title_font_size . ';color:' . $title_color . ' !important;">' . get_the_title() . '</span>';
		} else {
			$title = '';
		}
		if ( $image_size && has_post_thumbnail() && $include_link ) {
            if($link_to_source == 'yes')
            {
                $source_url = get_post_meta($post->ID, 'rfpge_post_url', true);
                if($source_url != '')
                {
                    $image = '<a class="rfpge_display_image" href="' . $source_url . '">' . get_the_post_thumbnail( get_the_ID(), $image_size ) . '</a> <br/>';
                }
                else
                {
                    $image = '<a class="rfpge_display_image" href="' . get_permalink() . '">' . get_the_post_thumbnail( get_the_ID(), $image_size ) . '</a> <br/>';
                }
            }
            else
            {
                $image = '<a class="rfpge_display_image" href="' . get_permalink() . '">' . get_the_post_thumbnail( get_the_ID(), $image_size ) . '</a> <br/>';
            }
		} elseif( $image_size && has_post_thumbnail() ) {
			$image = '<span class="rfpge_display_image">' . get_the_post_thumbnail( get_the_ID(), $image_size ) . '</span> <br/>';
		}
		if ( $include_date )
			$date = ' <span class="date">' . get_the_date( $date_format ) . '</span>';
		if( $include_author )
			$author = apply_filters( 'display_posts_shortcode_author', ' <span class="rfpge_display_author">by ' . get_the_author() . '</span>', $original_atts );
		if ( $include_excerpt ) {
			if( $excerpt_length || $excerpt_more || $excerpt_more_link ) {
				$length = $excerpt_length ? $excerpt_length : apply_filters( 'excerpt_length', 55 );
				$more   = $excerpt_more ? $excerpt_more : apply_filters( 'excerpt_more', '' );
				$more   = $excerpt_more_link ? ' <a href="' . get_permalink() . '">' . $more . '</a>' : ' ' . $more;
				if( has_excerpt() && apply_filters( 'display_posts_shortcode_full_manual_excerpt', false ) ) {
					$excerpt = $post->post_excerpt . $more;
				} elseif( has_excerpt() ) {
					$excerpt = wp_trim_words( strip_shortcodes( $post->post_excerpt ), $length, $more );
				} else {
					$excerpt = wp_trim_words( strip_shortcodes( $post->post_content ), $length, $more );
				}
			} else {
				$excerpt = get_the_excerpt();
			}
			$excerpt = ' <br/><br/> <span class="rfpge_display_excerpt" style="font-size:' . $excerpt_font_size . ';color:' . $excerpt_color . ' !important;">' . $excerpt . '</span>';
            if($read_more_text != '')
            {
                if($link_to_source == 'yes')
                {
                    $source_url = get_post_meta($post->ID, 'rfpge_post_url', true);
                    if($source_url != '')
                    {
                        $excerpt .= '<br/><a href="' . $source_url . '"><span class="rfpge_display_excerpt" style="font-size:' . $excerpt_font_size . ';color:' . $excerpt_color . ' !important;">' . $read_more_text . '</span></a>';
                    }
                    else
                    {
                        $excerpt .= '<br/><a href="' . get_permalink() . '"><span class="rfpge_display_excerpt" style="font-size:' . $excerpt_font_size . ';color:' . $excerpt_color . ' !important;">' . $read_more_text . '</span></a>';
                    }
                }
                else
                {
                    $excerpt .= '<br/><a href="' . get_permalink() . '"><span class="rfpge_display_excerpt" style="font-size:' . $excerpt_font_size . ';color:' . $excerpt_color . ' !important;">' . $read_more_text . '</span></a>';
                }
            }
		}
		if( $include_content ) {
			add_filter( 'shortcode_atts_display-posts', 'rfpge_display_posts_off', 10, 3 );
			$content = '<div class="' . implode( ' ', $content_class ) . '">' . apply_filters( 'the_content', get_the_content() ) . '</div>';
			remove_filter( 'shortcode_atts_display-posts', 'rfpge_display_posts_off', 10, 3 );
		}
		$category_display_text = '';
		if( $category_display && is_object_in_taxonomy( get_post_type(), $category_display ) ) {
			$terms = get_the_terms( get_the_ID(), $category_display );
			$term_output = array();
			foreach( $terms as $term )
				$term_output[] = '<a href="' . get_term_link( $term, $category_display ) . '">' . $term->name . '</a>';
			$category_display_text = ' <span class="category-display"><span class="category-display-label">' . $category_label . '</span> ' . implode( ', ', $term_output ) . '</span>';
			$category_display_text = apply_filters( 'display_posts_shortcode_category_display', $category_display_text );
		}
		$class = array( 'listing-item' );
		$class = array_map( 'sanitize_html_class', apply_filters( 'display_posts_shortcode_post_class', $class, $post, $listing, $original_atts ) );
		$output = '<br/><' . $inner_wrapper . ' class="' . implode( ' ', $class ) . '">' . $image . $title . $date . $author . $category_display_text . $excerpt . $content . '</' . $inner_wrapper . '><br/><br/><hr style="border-top: dotted 1px;"/>';		$inner .= apply_filters( 'display_posts_shortcode_output', $output, $original_atts, $image, $title, $date, $excerpt, $inner_wrapper, $content, $class );
	endwhile; wp_reset_postdata();
    wp_suspend_cache_addition(false);
	$open = apply_filters( 'display_posts_shortcode_wrapper_open', '<' . $wrapper . $wrapper_class . $wrapper_id . '>', $original_atts );
	$close = apply_filters( 'display_posts_shortcode_wrapper_close', '</' . $wrapper . '>', $original_atts );
	$return = $open;
	if( $shortcode_title ) {
		$title_tag = apply_filters( 'display_posts_shortcode_title_tag', 'h2', $original_atts );
		$return .= '<' . $title_tag . ' class="display-posts-title">' . $shortcode_title . '</' . $title_tag . '>' . "\n";
	}
	$return .= $inner . $close;
	return $return;
}
function rfpge_sanitize_date_time( $date_time, $type = 'date', $accepts_string = false ) {
	if ( empty( $date_time ) || ! in_array( $type, array( 'date', 'time' ) ) ) {
		return array();
	}
	$segments = array();
	if (
		true === $accepts_string
		&& ( false !== strpos( $date_time, ' ' ) || false === strpos( $date_time, '-' ) )
	) {
		if ( false !== $timestamp = strtotime( $date_time ) ) {
			return $date_time;
		}
	}
	$parts = array_map( 'absint', explode( 'date' == $type ? '-' : ':', $date_time ) );
	if ( 'date' == $type ) {
		$year = $month = $day = 1;
		if ( count( $parts ) >= 3 ) {
			list( $year, $month, $day ) = $parts;
			$year  = ( $year  >= 1 && $year  <= 9999 ) ? $year  : 1;
			$month = ( $month >= 1 && $month <= 12   ) ? $month : 1;
			$day   = ( $day   >= 1 && $day   <= 31   ) ? $day   : 1;
		}
		$segments = array(
			'year'  => $year,
			'month' => $month,
			'day'   => $day
		);
	} elseif ( 'time' == $type ) {
		$hour = $minute = $second = 0;
		switch( count( $parts ) ) {
			case 3 :
				list( $hour, $minute, $second ) = $parts;
				$hour   = ( $hour   >= 0 && $hour   <= 23 ) ? $hour   : 0;
				$minute = ( $minute >= 0 && $minute <= 60 ) ? $minute : 0;
				$second = ( $second >= 0 && $second <= 60 ) ? $second : 0;
				break;
			case 2 :
				list( $hour, $minute ) = $parts;
				$hour   = ( $hour   >= 0 && $hour   <= 23 ) ? $hour   : 0;
				$minute = ( $minute >= 0 && $minute <= 60 ) ? $minute : 0;
				break;
			default : break;
		}
		$segments = array(
			'hour'   => $hour,
			'minute' => $minute,
			'second' => $second
		);
	}

	return apply_filters( 'display_posts_shortcode_sanitized_segments', $segments, $date_time, $type );
}

function rfpge_display_posts_off( $out, $pairs, $atts ) {
	$out['display_posts_off'] = apply_filters( 'display_posts_shortcode_inception_override', true );
	return $out;
}
add_shortcode( 'echo-list-posts', 'rfpge_list_posts' );
function rfpge_list_posts( $atts ) {
    ob_start();
    extract( shortcode_atts( array (
        'type' => 'any',
        'order' => 'ASC',
        'orderby' => 'title',
        'posts' => 50,
        'category' => '',
        'ruleid' => ''
    ), $atts ) );
    $options = array(
        'post_type' => $type,
        'order' => $order,
        'orderby' => $orderby,
        'posts_per_page' => $posts,
        'category_name' => $category,
        'meta_key' => 'rfpge_parent_rule',
        'meta_value' => $ruleid
    );
    $query = new WP_Query( $options );
    if ( $query->have_posts() ) { ?>
        <ul class="clothes-listing">
            <?php while ( $query->have_posts() ) : $query->the_post(); ?>
            <li id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
                <a href="<?php the_permalink(); ?>"><?php the_title(); ?></a>
            </li>
            <?php endwhile;
            wp_reset_postdata(); ?>
        </ul>
    <?php $myvariable = ob_get_clean();
    return $myvariable;
    }
    return '';
}

register_deactivation_hook(__FILE__, 'rfpge_my_deactivation');
function rfpge_my_deactivation()
{
    wp_clear_scheduled_hook('echoaction');
    wp_clear_scheduled_hook('echoactionclear');
    $running = array();
    update_option('rfpge_running_list', $running, false);
    rfpge_delete_system_cron();
}
add_action('echoaction', 'rfpge_cron');
add_action('echoactionclear', 'rfpge_auto_clear_log');
if (is_admin()) {
    rfpge_cron_schedule();
}
function rfpge_cron_schedule()
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if (isset($echo_Main_Settings['rfpge_enabled']) && $echo_Main_Settings['rfpge_enabled'] === 'on') {
        if (!wp_next_scheduled('echoaction')) {
            $unlocker = get_option('rfpge_minute_running_unlocked', false);
            if($unlocker == '1')
            {
                $rez = wp_schedule_event(time(), 'minutely', 'echoaction');
            }
            else
            {
                $rez = wp_schedule_event(time(), 'hourly', 'echoaction');
            }
            if ($rez === FALSE) {
                rfpge_log_to_file('[Scheduler] Failed to schedule echoaction to rfpge_cron!');
            }
        }
        
        if (isset($echo_Main_Settings['enable_logging']) && $echo_Main_Settings['enable_logging'] === 'on' && isset($echo_Main_Settings['auto_clear_logs']) && $echo_Main_Settings['auto_clear_logs'] !== 'No') {
            if (!wp_next_scheduled('echoactionclear')) {
                $rez = wp_schedule_event(time(), $echo_Main_Settings['auto_clear_logs'], 'echoactionclear');
                if ($rez === FALSE) {
                    rfpge_log_to_file('[Scheduler] Failed to schedule echoactionclear to ' . $echo_Main_Settings['auto_clear_logs'] . '!');
                }
                add_option('rfpge_schedule_time', $echo_Main_Settings['auto_clear_logs']);
            } else {
                if (!get_option('rfpge_schedule_time')) {
                    wp_clear_scheduled_hook('echoactionclear');
                    $rez = wp_schedule_event(time(), $echo_Main_Settings['auto_clear_logs'], 'echoactionclear');
                    add_option('rfpge_schedule_time', $echo_Main_Settings['auto_clear_logs']);
                    if ($rez === FALSE) {
                        rfpge_log_to_file('[Scheduler] Failed to schedule echoactionclear to ' . $echo_Main_Settings['auto_clear_logs'] . '!');
                    }
                } else {
                    $the_time = get_option('rfpge_schedule_time');
                    if ($the_time != $echo_Main_Settings['auto_clear_logs']) {
                        wp_clear_scheduled_hook('echoactionclear');
                        delete_option('rfpge_schedule_time');
                        $rez = wp_schedule_event(time(), $echo_Main_Settings['auto_clear_logs'], 'echoactionclear');
                        add_option('rfpge_schedule_time', $echo_Main_Settings['auto_clear_logs']);
                        if ($rez === FALSE) {
                            rfpge_log_to_file('[Scheduler] Failed to schedule echoactionclear to ' . $echo_Main_Settings['auto_clear_logs'] . '!');
                        }
                    }
                }
            }
        } else {
            if (!wp_next_scheduled('echoactionclear')) {
                delete_option('rfpge_schedule_time');
            } else {
                wp_clear_scheduled_hook('echoactionclear');
                delete_option('rfpge_schedule_time');
            }
        }
    } else {
        if (wp_next_scheduled('echoaction')) {
            wp_clear_scheduled_hook('echoaction');
        }
        
        if (!wp_next_scheduled('echoactionclear')) {
            delete_option('rfpge_schedule_time');
        } else {
            wp_clear_scheduled_hook('echoactionclear');
            delete_option('rfpge_schedule_time');
        }
    }
}
function rfpge_cron()
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if (isset($echo_Main_Settings['rfpge_enabled']) && $echo_Main_Settings['rfpge_enabled'] === 'on') {
        if (isset($echo_Main_Settings['auto_delete_enabled']) && $echo_Main_Settings['auto_delete_enabled'] === 'on') {
            $postsPerPage = 50000;
            $paged = 0;
            do
            {
                $postOffset = $paged * $postsPerPage;
                $query              = array(
                    'post_status' => array(
                        'publish',
                        'draft',
                        'pending',
                        'trash',
                        'private',
                        'future'
                    ),
                    'post_type' => array(
                        'any'
                    ),
                    'numberposts' => $postsPerPage,
                    'fields' => 'ids',
                    'meta_key' => 'rfpge_delete_time',
                    'offset'  => $postOffset
                );
                $post_list          = get_posts($query);
                $paged++;
                wp_suspend_cache_addition(true);
                foreach($post_list as $p)
                {
                    $exp_time = get_post_meta($p, 'rfpge_delete_time', true);
                    if($exp_time != '' && $exp_time !== false)
                    {
                        if(time() > $exp_time)
                        {
                            $args             = array(
                                'post_parent' => $p
                            );
                            $post_attachments = get_children($args);
                            if (isset($post_attachments) && !empty($post_attachments)) {
                                foreach ($post_attachments as $attachment) {
                                    wp_delete_attachment($attachment->ID, true);
                                }
                            }
                            $res = wp_delete_post($p, true);
                            if ($res === false) {
                                rfpge_log_to_file('[Scheduler] Failed to automatically delete post ' . $p . ', exptime: ' . $exp_time . ', time: ' . time() . '!');
                            }
                        }
                    }
                }
                wp_suspend_cache_addition(false);
            }while(!empty($post_list));
            $post_list = null;
            unset($post_list);
        }
        $GLOBALS['wp_object_cache']->delete('rfpge_running_list', 'options');
        $running = get_option('rfpge_running_list');
        $curr_time = time();
        $update = false;
        if(is_array($running))
        {
            foreach($running as $key => $value)
            {
                if(($curr_time - $key > 3600) && $key > 1000)
                {
                    unset($running[$key]);
                    $update = true;
                }
            }
        }
        if($update === true)
        {
            update_option('rfpge_running_list', $running);
        }
        
        if (!get_option('echo_rules_list')) {
            $rules = array();
        } else {
            $rules = get_option('echo_rules_list');
        }
        $rule_run = false;
        $unlocker = get_option('rfpge_minute_running_unlocked', false);
        if (!empty($rules)) {
            $cont = 0;
            foreach ($rules as $request => $bundle[]) {
                $bundle_values   = array_values($bundle);
                $myValues        = $bundle_values[$cont];
                $array_my_values = array_values($myValues);
                $schedule        = isset($array_my_values[1]) ? $array_my_values[1] : '24';
                $active          = isset($array_my_values[2]) ? $array_my_values[2] : '0';
                $last_run        = isset($array_my_values[3]) ? $array_my_values[3] : rfpge_get_date_now();
                if ($active == '1') {
                    $now            = rfpge_get_date_now();
                    if($unlocker == '1')
                    {
                        $nextrun        = rfpge_add_minute($last_run, $schedule);
                        $rfpge_hour_diff = (int) rfpge_minute_diff($now, $nextrun);
                    }
                    else
                    {
                        $nextrun        = rfpge_add_hour($last_run, $schedule);
                        $rfpge_hour_diff = (int) rfpge_hour_diff($now, $nextrun);
                    }
                    if ($rfpge_hour_diff >= 0) {
                        if($rule_run === false)
                        {
                            $rule_run = true;
                        }
                        else
                        {
                            if (isset($echo_Main_Settings['rule_delay']) && $echo_Main_Settings['rule_delay'] !== '')
                            {
                                sleep($echo_Main_Settings['rule_delay']);
                            }
                        }
                        rfpge_run_rule($cont); 
                    }
                }
                $cont = $cont + 1;
            }
            $running = array();
            update_option('rfpge_running_list', $running);
        }
    }
}
function rfpge_add_ajaxurl()
{
    echo '<script type="text/javascript">
            var ajaxurl = "' . admin_url('admin-ajax.php') . '";
        </script>';
}
function rfpge_log_to_file($str)
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if (isset($echo_Main_Settings['enable_logging']) && $echo_Main_Settings['enable_logging'] == 'on') {
        $d = date("j-M-Y H:i:s e");
        error_log("[$d] " . $str . "\r\n", 3, WP_CONTENT_DIR . '/rfpge_info.log');
    }
}
function rfpge_delete_all_posts()
{
    $failed             = false;
    $number             = 0;
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    $postsPerPage = 50000;
    $paged = 0;
    do
    {
        $postOffset = $paged * $postsPerPage;
        $query              = array(
            'post_status' => array(
                'publish',
                'draft',
                'pending',
                'trash',
                'private',
                'future'
            ),
            'post_type' => array(
                'any'
            ),
            'numberposts' => $postsPerPage,
            'fields' => 'ids',
            'meta_key' => 'rfpge_parent_rule',
            'offset'  => $postOffset
        );
        $post_list          = get_posts($query);
        $paged++;
        wp_suspend_cache_addition(true);
        foreach ($post_list as $post) {
            $index = get_post_meta($post, 'rfpge_parent_rule', true);
            if (isset($index) && $index !== '') {
                $args             = array(
                    'post_parent' => $post
                );
                $post_attachments = get_children($args);
                if (isset($post_attachments) && !empty($post_attachments)) {
                    foreach ($post_attachments as $attachment) {
                        wp_delete_attachment($attachment->ID, true);
                    }
                }
                $res = wp_delete_post($post, true);
                if ($res === false) {
                    $failed = true;
                } else {
                    $number++;
                }
            }
        }
        wp_suspend_cache_addition(false);
    }while(!empty($post_list));
    $post_list = null;
    unset($post_list);
    if ($failed === true) {
        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
            rfpge_log_to_file('[PostDelete] Failed to delete all posts!');
        }
    } else {
        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
            rfpge_log_to_file('[PostDelete] Successfuly deleted ' . $number . ' posts!');
        }
    }
}
function rfpge_delete_all_rules()
{
    update_option('echo_rules_list', array());
}
function rfpge_replaceContentShortcodes($the_content, $just_title, $content, $item_url, $item_cat, $item_tags, $item_image, $feed_title, $feed_description, $description, $feed_logo, $author, $author_link, $author_email, $read_more, $date)
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if (isset($echo_Main_Settings['custom_html'])) {
        $the_content = str_replace('%%custom_html%%', html_entity_decode($echo_Main_Settings['custom_html']), $the_content);
    }
    if (isset($echo_Main_Settings['custom_html2'])) {
        $the_content = str_replace('%%custom_html2%%', html_entity_decode($echo_Main_Settings['custom_html2']), $the_content);
    }
    $the_content = str_replace('%%random_sentence%%', rfpge_random_sentence_generator(), $the_content);
    $the_content = str_replace('%%random_sentence2%%', rfpge_random_sentence_generator(false), $the_content);
    $the_content = str_replace('%%item_title%%', $just_title, $the_content);
    $the_content = str_replace('%%item_content%%', $content, $the_content);
    $the_content = str_replace('%%item_url%%', $item_url, $the_content);
    $the_content = str_replace('%%item_cat%%', $item_cat, $the_content);
    $the_content = str_replace('%%item_tags%%', $item_tags, $the_content);
    $the_content = str_replace('%%item_content_plain_text%%', rfpge_getPlainContent($content), $the_content);
    $the_content = str_replace('%%item_read_more_button%%', rfpge_getReadMoreButton($item_url, $read_more), $the_content);
    $the_content = str_replace('%%item_show_image%%', rfpge_getItemImage($item_image), $the_content);
    $the_content = str_replace('%%item_image_URL%%', $item_image, $the_content);
    $the_content = str_replace('%%feed_title%%', $feed_title, $the_content);
    $the_content = str_replace('%%feed_description%%', $feed_description, $the_content);
    $the_content = str_replace('%%item_description%%', $description, $the_content);
    $the_content = str_replace('%%item_pub_date%%', $date, $the_content);
    $the_content = str_replace('%%feed_logo%%', $feed_logo, $the_content);
    $the_content = str_replace('%%author%%', $author, $the_content);
    $the_content = str_replace('%%author_link%%', $author_link, $the_content);
    $the_content = str_replace('%%author_email%%', $author_email, $the_content);
    return $the_content;
}

function rfpge_replaceTitleShortcodes($the_content, $just_title, $content, $item_url, $item_cat, $item_tags)
{
    $the_content = str_replace('%%random_sentence%%', rfpge_random_sentence_generator(), $the_content);
    $the_content = str_replace('%%random_sentence2%%', rfpge_random_sentence_generator(false), $the_content);
    $the_content = str_replace('%%item_title%%', $just_title, $the_content);
    $the_content = str_replace('%%item_description%%', $content, $the_content);
    $the_content = str_replace('%%item_url%%', $item_url, $the_content);
    $the_content = str_replace('%%item_cat%%', $item_cat, $the_content);
    $the_content = str_replace('%%item_tags%%', $item_tags, $the_content);
    return $the_content;
}

add_action('wp_head', 'rfpge_add_ajaxurl');
add_action('wp_ajax_rfpge_my_action', 'rfpge_my_action_callback');
function rfpge_my_action_callback()
{
    check_ajax_referer( 'rfpge_my_action_callback', 'security' );
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    $failed             = false;
    $del_id             = $_POST['id'];
    $how                = $_POST['how'];
    $del_id = sanitize_text_field( $del_id );
    $how = sanitize_text_field( $how );
    if(!is_numeric($del_id) || ($how != 'delete' && $how != 'trash' && $how != 'duplicate'))
    {
        echo 'failed';
        die();
    }
    if($how == 'duplicate')
    {
        $GLOBALS['wp_object_cache']->delete('echo_rules_list', 'options');
        if (!get_option('echo_rules_list')) {
            $rules = array();
        } else {
            $rules = get_option('echo_rules_list');
        }
        if (!empty($rules)) {
            $found            = 0;
            $cont = 0;
            foreach ($rules as $request => $bundle[]) {
                if ($cont == $del_id) {
                    $copy_bundle = $rules[$request];
                    $copy_bundle[37] = uniqid('', true);
                    $rules[] = $copy_bundle;
                    $found   = 1;
                    break;
                }
                $cont = $cont + 1;
            }
            if($found == 0)
            {
                rfpge_log_to_file('echo_rules_list index not found: ' . $del_id);
                echo 'nochange';
                die();
            }
            else
            {
                update_option('echo_rules_list', $rules);
                echo 'ok';
                die();
            }
        } else {
            rfpge_log_to_file('echo_rules_list empty!');
            echo 'nochange';
            die();
        }
        
    }
    $force_delete       = true;
    $number             = 0;
    if ($how == 'trash') {
        $force_delete = false;
    }
    $postsPerPage = 50000;
    $paged = 0;
    do
    {
        $postOffset = $paged * $postsPerPage;
        $query     = array(
            'post_status' => array(
                'publish',
                'draft',
                'pending',
                'trash',
                'private',
                'future'
            ),
            'post_type' => array(
                'any'
            ),
            'numberposts' => $postsPerPage,
            'fields' => 'ids',
            'meta_key' => 'rfpge_parent_rule',
            'offset'  => $postOffset
        );
        $post_list = get_posts($query);
        $paged++;
        wp_suspend_cache_addition(true);
        foreach ($post_list as $post) {
            $index = get_post_meta($post, 'rfpge_parent_rule', true);
            if ($index == $del_id) {
                $args             = array(
                    'post_parent' => $post
                );
                $post_attachments = get_children($args);
                if (isset($post_attachments) && !empty($post_attachments)) {
                    foreach ($post_attachments as $attachment) {
                        wp_delete_attachment($attachment->ID, true);
                    }
                }
                $res = wp_delete_post($post, $force_delete);
                if ($res === false) {
                    $failed = true;
                } else {
                    $number++;
                }
            }
        }
        wp_suspend_cache_addition(false);
    }while(!empty($post_list));
    $post_list = null;
    unset($post_list);
    if ($failed === true) {
        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
            rfpge_log_to_file('[PostDelete] Failed to delete all posts for rule id: ' . $del_id . '!');
        }
        echo 'failed';
    } else {
        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
            rfpge_log_to_file('[PostDelete] Successfuly deleted ' . $number . ' posts for rule id: ' . $del_id . '!');
        }
        if ($number == 0) {
            echo 'nochange';
        } else {
            echo 'ok';
        }
    }
    die();
}
add_action('wp_ajax_rfpge_run_my_action', 'rfpge_run_my_action_callback');
function rfpge_run_my_action_callback()
{
    check_ajax_referer( 'rfpge_run_my_action_callback', 'security' );
    $run_id = $_POST['id'];
    $run_id = sanitize_text_field( $run_id );
    if(is_numeric($run_id))
    {
        echo rfpge_run_rule($run_id, 0);
    }
    else
    {
        echo 'failed';
    }
    die();
}

function rfpge_clearFromList($param)
{
    $GLOBALS['wp_object_cache']->delete('rfpge_running_list', 'options');
    $running = get_option('rfpge_running_list');
    $key     = array_search($param, $running);
    if ($key !== FALSE) {
        unset($running[$key]);
        update_option('rfpge_running_list', $running);
    }
}

function rfpge_curl_exec_utf8($ch) {
    $data = curl_exec($ch);
    if (!is_string($data))
    {
        rfpge_log_to_file('Failed to exec curl in rfpge_curl_exec_utf8! ' . curl_error($ch) . ' - ' . curl_errno($ch));
        return $data;
    } 
    unset($charset);
    $content_type = curl_getinfo($ch, CURLINFO_CONTENT_TYPE);
    preg_match( '@([\w/+]+)(;\s*charset=(\S+))?@i', $content_type, $matches );
    if ( isset( $matches[3] ) )
        $charset = $matches[3];
    if (!isset($charset)) {
        preg_match( '@<meta\s+http-equiv="Content-Type"\s+content="([\w/]+)(;\s*charset=([^\s"]+))?@i', $data, $matches );
        if ( isset( $matches[3] ) )
            $charset = $matches[3];
    }
    if (!isset($charset)) {
        preg_match( '@<\?xml.+encoding="([^\s"]+)@si', $data, $matches );
        if ( isset( $matches[1] ) )
            $charset = $matches[1];
    }
    if (!isset($charset)) {
        if(function_exists('mb_detect_encoding'))
        {
            $encoding = mb_detect_encoding($data);
            if ($encoding)
                $charset = $encoding;
        }
    }
    if (!isset($charset)) {
        if (strstr($content_type, "text/html") === 0)
            $charset = "ISO 8859-1";
    }
    if (isset($charset) && strtoupper($charset) != "UTF-8")
    {   
        $data = @iconv($charset, 'UTF-8//IGNORE', $data);
    }
    if($data === false)
    {
        return curl_exec($ch);
    }
    return $data;
}

function rfpge_get_web_page($url)
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    $user_agent = 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.2062.124 Safari/537.36';
    $args    = array(
            'user-agent' => $user_agent,
            'timeout' => 90,
            'redirection' => 10
    );
    $content = wp_remote_get( $url, $args );
    if(is_wp_error( $content ))
    {
        return false;
    }
    return $content['body'];
}

add_action('wp_feed_options', 'rfpge_force_feed', 10, 2); 
function rfpge_force_feed($feed, $url) {
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if (isset($echo_Main_Settings['rfpge_enabled']) && $echo_Main_Settings['rfpge_enabled'] == 'on') {
        if ((isset($echo_Main_Settings['rfpge_force_feeds']) && $echo_Main_Settings['rfpge_force_feeds'] == 'on') || (strpos($url, 'feeds.bbci.co.uk') !== false)) {
            $feed->force_feed(true);
        }
    }
}

function rfpge_check_if_video($str)
{
    if(preg_match('/^.*\.(avi|flv|f4v|f4p|f4a|f4b|webm|vob|ogv|ogg|drc|qt|yuv|rm|rmvb|asf|amv|m4p|mpe|mpv|m2v|m4v|svi|3gp|3g2|mxf|roq|nsv|mp4|mov|mpg|mpeg|wmv|mkv)$/i', $str))
    {
        return true;
    }
    else
    {
        return false;
    }
}

function rfpge_get_featured_image($url, $content, $item, $orig_content, $skip_og, $skip_feed_image, $skip_first_img, $skip_post_content)
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    $html_data = false;
    if($skip_feed_image != '1')
    {
        if($feed_enclosure = $item->get_enclosure())
        {
            $get_img = $feed_enclosure->get_thumbnail();
            if ($get_img != '' && $get_img != '//?#') {
                $get_img = strtok($get_img, '?');
                return $get_img;
            }
        }
    }
    if (isset($echo_Main_Settings['rfpge_get_image_from_content']) && $echo_Main_Settings['rfpge_get_image_from_content'] == 'on' && (stripos($url, 'rss.careerjet.ae') === false)) { 
        if($skip_og != '1')
        {
            $html_data = rfpge_get_web_page($url);
            if($html_data !== false)
            {
                preg_match('{<meta[^<]*?property=["|\']og:image["|\'][^<]*?>}s', $html_data,$mathc);
                if(@stristr($mathc[0], 'og:image')){
                    preg_match('{content=["|\'](.*?)["|\']}s', $mathc[0],$matx);
                    if(isset($matx[1]))
                    {
                        $og_img = $matx[1];
                        if(trim($og_img) !='')
                        {
                            return $og_img;
                        }
                    }
                }
            }
        }
    }
    if($skip_post_content != '1')
    {
        $dom     = new DOMDocument();
        @$dom->loadHTML($content);
        $tags      = $dom->getElementsByTagName('img');
        foreach ($tags as $tag) {
            $temp_get_img = $tag->getAttribute('src');
            if ($temp_get_img != '') {
                $temp_get_img = strtok($temp_get_img, '?');
                return rtrim($temp_get_img, '/');
            }
        }
        if($orig_content != '')
        {
            $dom2     = new DOMDocument();
            @$dom2->loadHTML($orig_content);
            $tags = $dom2->getElementsByTagName('img');
            foreach ($tags as $tag) {
                $temp_get_img = $tag->getAttribute('src');
                if ($temp_get_img != '') {
                    $temp_get_img = strtok($temp_get_img, '?');
                    return rtrim($temp_get_img, '/');
                }
            }
        }
        $count = 0;
        $biggest_img = '';           
        if (isset($echo_Main_Settings['rfpge_get_image_from_content']) && $echo_Main_Settings['rfpge_get_image_from_content'] == 'on' && (stripos($url, 'rss.careerjet.ae') === false)) { 
            if($skip_og == '1')
            {
                $html_data = rfpge_get_web_page($url);
            }
            if($html_data !== false)
            {
                $doc = new DOMDocument();
                @$doc->loadHTML($html_data);
                $tags    = $doc->getElementsByTagName('img');
                $maxSize = 0;
                foreach ($tags as $tag) {
                    $temp_get_img = $tag->getAttribute('src');
                    if ($temp_get_img != '') {
                        $temp_get_img = strtok($temp_get_img, '?');
                        $temp_get_img   = rtrim($temp_get_img, '/');
                        $image=@getimagesize($temp_get_img);
                        $count++;
                        if(isset($image[0]) && isset($image[1]) && is_numeric($image[0]) && is_numeric($image[1]))
                        {
                            if (($image[0] * $image[1]) > $maxSize) {   
                                $maxSize = $image[0] * $image[1]; 
                                $biggest_img = $temp_get_img;
                            }
                        }
                    }
                }
            }
        }
        if($count == 1 && $skip_first_img == '1')
        {
            return '';
        }
        return $biggest_img;
    }
    return ''; 
}

function rfpge_wpse_allowedtags() {
        return '<script>,<style>,<br>,<em>,<i>,<ul>,<ol>,<li>,<a>,<p>,<img>,<video>,<audio>'; 
}
    
function rfpge_custom_wp_trim_excerpt($raw_excerpt, $excerpt_word_count, $more_url, $read_more) {
    $wpse_excerpt = $raw_excerpt;
            $wpse_excerpt = strip_shortcodes( $wpse_excerpt );
            $wpse_excerpt = apply_filters('the_content', $wpse_excerpt);
            $wpse_excerpt = str_replace(']]>', ']]&gt;', $wpse_excerpt);
            $wpse_excerpt = strip_tags($wpse_excerpt, rfpge_wpse_allowedtags());
                $tokens = array();
                $excerptOutput = '';
                $count = 0;
                preg_match_all('/(<[^>]+>|[^<>\s]+)\s*/u', $wpse_excerpt, $tokens);
                foreach ($tokens[0] as $token) { 

                    if ($count >= $excerpt_word_count && preg_match('/[\,\;\?\.\!]\s*$/uS', $token)) { 
                        $excerptOutput .= trim($token);
                        break;
                    }
                    $count++;
                    $excerptOutput .= $token;
                }
            $wpse_excerpt = trim(force_balance_tags($excerptOutput));
            $echo_Main_Settings = get_option('echo_Main_Settings', false);
            if($read_more == '')
            {
                if (isset($echo_Main_Settings['read_more_text']) && $echo_Main_Settings['read_more_text'] != '') {
                    $read_more = $echo_Main_Settings['read_more_text'];
                }
                else
                {
                    $read_more = 'Read More';
                }
            }
            $excerpt_end = ' <a href="'. $more_url . '" target="_blank">&nbsp;&raquo;&nbsp;' . $read_more . '</a>'; 
            $wpse_excerpt .= $excerpt_end;
        return $wpse_excerpt;
}

add_action('publish_post', 'rfpge_send_admin_email');
function rfpge_send_admin_email($post_id)
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if (isset($echo_Main_Settings['rfpge_enabled']) && $echo_Main_Settings['rfpge_enabled'] == 'on') {
        if (isset($echo_Main_Settings['send_post_email']) && $echo_Main_Settings['send_post_email'] == 'on') {
            $to = $echo_Main_Settings['email_address'];
            if (!filter_var($to, FILTER_VALIDATE_EMAIL) === false)
            {
                $subject   = get_the_title($post_id);
                $content_post = get_post($post_id);
                $message = $content_post->post_content;
                $message = apply_filters('the_content', $message);
                $message = str_replace(']]>', ']]&gt;', $message);
                $headers[] = 'From: Echo Plugin <echo@noreply.net>';
                $headers[] = 'Reply-To: noreply@echo.com';
                $headers[] = 'X-Mailer: PHP/' . phpversion();
                $headers[] = 'Content-Type: text/html';
                $headers[] = 'Charset: ' . get_option('blog_charset', 'UTF-8');
                wp_mail($to, $subject, $message, $headers);
            }
        }
    }
}
function rfpge_my_list_cats() {
    $catsArray = array();
    $cat_args   = array(
        'orderby' => 'name',
        'hide_empty' => 0,
        'order' => 'ASC'
    );
    $categories = get_categories($cat_args);
    foreach($categories as $cat) {
        $catsArray[] = $cat->name;
    }
    return $catsArray;
}

function rfpge_run_rule($param, $auto = 1)
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if (isset($echo_Main_Settings['rule_timeout']) && $echo_Main_Settings['rule_timeout'] != '') {
        $timeout = intval($echo_Main_Settings['rule_timeout']);
    } else {
        $timeout = 3600;
    }
    $draft_me = false;
    @ini_set('memory_limit', '-1');
    @ini_set('default_socket_timeout', $timeout);
    @ini_set('safe_mode', 'Off');
    @ini_set('max_execution_time', $timeout);
    @ini_set('ignore_user_abort', 1);
    @ini_set('user_agent', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.2062.124 Safari/537.36');
    ignore_user_abort(true);
    set_time_limit($timeout);
    $posts_inserted         = 0;
    $auto_generate_comments = '0';
    if (isset($echo_Main_Settings['rfpge_enabled']) && $echo_Main_Settings['rfpge_enabled'] == 'on') {
        try {
            $item_img         = '';
            $cont             = 0;
            $found            = 0;
            $ids              = '';
            $schedule         = '';
            $enable_comments  = '1';
            $enable_pingback  = '1';
            $author_link      = '';
            $author_email     = '';
            $max              = PHP_INT_MAX;
            $active           = '0';
            $last_run         = '';
            $ruleType         = 'week';
            $first            = false;
            $others           = array();
            $post_title       = '';
            $post_content     = '';
            $list_item        = '';
            $default_category = '';
            $extra_categories = '';
            $only_text       = '';
            $single          = '';
            $type            = '';
            $inner           = '';
            $expre           = '';
            $get_css         = '';
            $posted_items    = array();
            $post_status     = 'publish';
            $post_type       = 'post';
            $accept_comments = 'closed';
            $post_user_name  = 1;
            $full_content    = '0';
            $item_create_tag = '';
            $can_create_tag  = '0';
            $strip_images    = '0';
            $item_tags       = '';
            $max             = 50;
            $auto_categories = '0';
            $featured_image  = '0';
            $image_url       = '';
            $banned_words    = '';
            $required_words  = '';
            $strip_by_id     = '';
            $encoding        = 'NO_CHANGE';
            $strip_by_class  = '';
            $post_format     = 'post-format-standard';
            $post_array      = array();
            $limit_word_count = '';
            $import_date     = '0';
            $translate       = 'disabled';
            $remove_default  = '0';
            $rule_unique_id  = '';
            $read_more       = '';
            $skip_og         = '0';
            $skip_feed_image = '0';
            $remove_cats     = '';
            $auto_delete     = '';
            $skip_first_img  = '0';
            $content_percent = '';
            $skip_post_content = '0';
            $custom_fields   = '';
            $source_lang     = 'en';
            $strip_by_regex  = '';
            $replace_regex   = '';
            
            if (!get_option('echo_rules_list')) {
                $rules = array();
            } else {
                $rules = get_option('echo_rules_list');
            }
            if (!empty($rules)) {
                foreach ($rules as $request => $bundle[]) {
                    if ($cont == $param) {
                        $bundle_values    = array_values($bundle);
                        $myValues         = $bundle_values[$cont];
                        $array_my_values  = array_values($myValues);
                        $ids              = isset($array_my_values[0]) ? $array_my_values[0] : '';
                        $schedule         = isset($array_my_values[1]) ? $array_my_values[1] : '';
                        $active           = isset($array_my_values[2]) ? $array_my_values[2] : '';
                        $last_run         = isset($array_my_values[3]) ? $array_my_values[3] : '';
                        $max              = isset($array_my_values[4]) ? $array_my_values[4] : '';
                        $post_status      = isset($array_my_values[5]) ? $array_my_values[5] : '';
                        $post_type        = isset($array_my_values[6]) ? $array_my_values[6] : '';
                        $post_user_name   = isset($array_my_values[7]) ? $array_my_values[7] : '';
                        $item_create_tag  = isset($array_my_values[8]) ? $array_my_values[8] : '';
                        $default_category = isset($array_my_values[9]) ? $array_my_values[9] : '';
                        $auto_categories  = isset($array_my_values[10]) ? $array_my_values[10] : '';
                        $can_create_tag   = isset($array_my_values[11]) ? $array_my_values[11] : '';
                        $enable_comments  = isset($array_my_values[12]) ? $array_my_values[12] : '';
                        $featured_image   = isset($array_my_values[13]) ? $array_my_values[13] : '';
                        $image_url        = isset($array_my_values[14]) ? $array_my_values[14] : '';
                        $post_title       = isset($array_my_values[15]) ? htmlspecialchars_decode($array_my_values[15]) : '';
                        $post_content     = isset($array_my_values[16]) ? htmlspecialchars_decode($array_my_values[16]) : '';
                        $enable_pingback  = isset($array_my_values[17]) ? $array_my_values[17] : '';
                        $post_format      = isset($array_my_values[18]) ? $array_my_values[18] : '';
                        $full_content     = isset($array_my_values[19]) ? $array_my_values[19] : '';
                        $only_text        = isset($array_my_values[20]) ? $array_my_values[20] : '';
                        $single           = isset($array_my_values[21]) ? $array_my_values[21] : '';
                        $type             = isset($array_my_values[22]) ? $array_my_values[22] : '';
                        $inner            = isset($array_my_values[23]) ? $array_my_values[23] : '';
                        $expre            = isset($array_my_values[24]) ? $array_my_values[24] : '';
                        $get_css          = isset($array_my_values[25]) ? $array_my_values[25] : '';
                        $banned_words     = isset($array_my_values[26]) ? $array_my_values[26] : '';
                        $required_words   = isset($array_my_values[27]) ? $array_my_values[27] : '';
                        $strip_by_id      = isset($array_my_values[28]) ? $array_my_values[28] : '';
                        $strip_by_class   = isset($array_my_values[29]) ? $array_my_values[29] : '';
                        $encoding         = isset($array_my_values[30]) ? $array_my_values[30] : 'NO_CHANGE';
                        $limit_word_count = isset($array_my_values[31]) ? $array_my_values[31] : '';
                        $translate        = isset($array_my_values[32]) ? $array_my_values[32] : 'disabled';
                        //unused hideGoogle
                        $hideGoogle       = isset($array_my_values[33]) ? $array_my_values[33] : '';
                        $strip_images     = isset($array_my_values[34]) ? $array_my_values[34] : '';
                        $import_date      = isset($array_my_values[35]) ? $array_my_values[35] : '';
                        $remove_default   = isset($array_my_values[36]) ? $array_my_values[36] : '';
                        $rule_unique_id   = isset($array_my_values[37]) ? $array_my_values[37] : '';
                        $read_more        = isset($array_my_values[38]) ? $array_my_values[38] : '';
                        $skip_og          = isset($array_my_values[39]) ? $array_my_values[39] : '';
                        $skip_feed_image  = isset($array_my_values[40]) ? $array_my_values[40] : '';
                        $remove_cats      = isset($array_my_values[41]) ? $array_my_values[41] : '';
                        $auto_delete      = isset($array_my_values[42]) ? $array_my_values[42] : '';
                        $skip_first_img   = isset($array_my_values[43]) ? $array_my_values[43] : '';
                        $skip_post_content= isset($array_my_values[44]) ? $array_my_values[44] : '';
                        $content_percent  = isset($array_my_values[45]) ? $array_my_values[45] : '';
                        $custom_fields    = isset($array_my_values[46]) ? $array_my_values[46] : '';
                        $source_lang      = isset($array_my_values[47]) ? $array_my_values[47] : '';
                        $strip_by_regex   = isset($array_my_values[48]) ? $array_my_values[48] : '';
                        $replace_regex    = isset($array_my_values[49]) ? $array_my_values[49] : '';
                        $found            = 1;
                        break;
                    }
                    $cont = $cont + 1;
                }
            } else {
                rfpge_log_to_file('No rules found for echo_rules_list!');
                return 'fail';
            }
            $strip_by_regex = stripslashes($strip_by_regex);
            $replace_regex = stripslashes($replace_regex);
            if($source_lang == '' || $source_lang == 'disabled')
            {
                $source_lang = 'en';
            }
            if($rule_unique_id == '')
            {
                $rule_unique_id = $param;
            }
            if ($found == 0) {
                rfpge_log_to_file($param . ' not found in echo_rules_list!');
                return 'fail';
            } else {
                $rules[$param][3] = rfpge_get_date_now();
                update_option('echo_rules_list', $rules);
            }
            $GLOBALS['wp_object_cache']->delete('rfpge_running_list', 'options');
            $running = get_option('rfpge_running_list', array());
            if (!empty($running)) {
                if (in_array($rule_unique_id, $running)) {
                    if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                        rfpge_log_to_file('Only one instance of this rule is allowed. Rule is already running!');
                    }
                    return 'fail';
                }
            }
            $key = time();
            if(!isset($running[$key]))
            {
                $running[$key] = $rule_unique_id;
            }
            else
            {
                $running[$key + 1] = $rule_unique_id;
            }
            update_option('rfpge_running_list', $running, false);
            register_shutdown_function('rfpge_clear_flag_at_shutdown', $rule_unique_id);
            include_once (ABSPATH . WPINC . '/feed.php');
            if ($enable_comments == '1') {
                $accept_comments = 'open';
            }
            $feed_uri = $ids;
            $feed = fetch_feed ( $feed_uri );
            if (is_wp_error ( $feed )){
                rfpge_log_to_file('Error in parsing RSS feed (built-in method): ' . $feed->get_error_message() . ' for ' . $feed_uri . '!');
                if($auto == 1)
                {
                    rfpge_clearFromList($param);
                }
                return 'fail';
            }
            $feed_title       = $feed->get_title();
            $feed_description = $feed->get_description();
            $feed_logo        = $feed->get_image_url();
            if ($author = $feed->get_author()) {
                $author = $author->get_name();
                if (method_exists($author, 'get_link')) {
                    $author_link = $author->get_link();
                } else {
                    $author_link = '';
                }
                if (method_exists($author, 'get_email')) {
                    $author_email = $author->get_email();
                } else {
                    $author_email = '';
                }
            } else {
                $author       = '';
                $author_link  = '';
                $author_email = '';
            }
            $items     = $feed->get_items();
            $feed = null;
            unset($feed);
            if (isset($echo_Main_Settings['do_not_check_duplicates']) && $echo_Main_Settings['do_not_check_duplicates'] == 'on') {
            }
            else
            {
                $postsPerPage = 50000;
                $paged = 0;
                wp_suspend_cache_addition(true);
                do
                {
                    $postOffset = $paged * $postsPerPage;
                    $query     = array(
                        'post_status' => array(
                            'publish',
                            'draft',
                            'pending',
                            'trash',
                            'private',
                            'future'
                        ),
                        'post_type' => array(
                            'any'
                        ),
                        'numberposts' => $postsPerPage,
                        'fields' => 'ids',
                        'meta_key' => 'rfpge_item_title',
                        'offset'  => $postOffset
                    );
                    $post_list = get_posts($query);
                    foreach ($post_list as $post) {
                        $posted_items[get_post_meta($post, 'rfpge_item_title', true)] = '1';
                    }
                    $paged++;
                }while(!empty($post_list));
                wp_suspend_cache_addition(false);
                $post_list = null;
                unset($post_list);
            }
            $count = 1;
            if (isset($echo_Main_Settings['append_enclosure']) && $echo_Main_Settings['append_enclosure'] == 'on') {
                if (isset($echo_Main_Settings['iframe_resize_width']) && $echo_Main_Settings['iframe_resize_width'] !== '')
                {
                    $iframe_resize_width = ' width="' . $echo_Main_Settings['iframe_resize_width'] . '"'; 
                }
                else
                {
                    $iframe_resize_width = '';
                }
                if (isset($echo_Main_Settings['iframe_resize_height']) && $echo_Main_Settings['iframe_resize_height'] !== '')
                {
                    $iframe_resize_height = ' height="' . $echo_Main_Settings['iframe_resize_height'] . '"'; 
                }
                else
                {
                    $iframe_resize_height = '';
                }
            }
            foreach ($items as $item) {
                if ($count > intval($max)) {
                    break;
                }
                $url         = $item->get_permalink();
                $description = $item->get_description();
                $title       = $item->get_title();
                if (isset($posted_items[$title])) {
                    continue;
                }
                $content = $item->get_content();
                if (isset($echo_Main_Settings['append_enclosure']) && $echo_Main_Settings['append_enclosure'] == 'on') {
                    $enclosures = $item->get_enclosures();
                    if(is_array($enclosures))
                    {
                        foreach ($enclosures as $enclosure)
                        {
                            $content .= '<br/>' . '<embed style="cursor: pointer;" src="' . $enclosure->get_link() . '" type="' . $enclosure->get_real_type() . '"' . $iframe_resize_width . $iframe_resize_height . '></embed>';
                        }
                    }
                }
                if (isset($echo_Main_Settings['strip_scripts']) && $echo_Main_Settings['strip_scripts'] == 'on') {
                    $content = preg_replace('{<ins.*?ins>}s', '', $content);
                    $content = preg_replace('{<ins.*?>}s', '', $content);
                    $content = preg_replace('{<script.*?script>}s', '', $content);
                    $content = preg_replace('{\(adsbygoogle.*?\);}s', '', $content);
                }

                $date = $item->get_date();
                if (isset($echo_Main_Settings['skip_old']) && $echo_Main_Settings['skip_old'] == 'on' && isset($echo_Main_Settings['skip_year']) && $echo_Main_Settings['skip_year'] !== '' && isset($echo_Main_Settings['skip_month']) && isset($echo_Main_Settings['skip_day'])) {
                    $old_date      = $echo_Main_Settings['skip_day'] . '-' . $echo_Main_Settings['skip_month'] . '-' . $echo_Main_Settings['skip_year'];
                    $time_date     = strtotime($date);
                    $time_old_date = strtotime($old_date);
                    if ($time_date !== false && $time_old_date !== false) {
                        if ($time_date < $time_old_date) {
                            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                                rfpge_log_to_file('Skipping post "' . $title . '", because it is older than ' . $old_date . ' - posted on ' . $date);
                            }
                            continue;
                        }
                    }
                }
                $extra_categories = '';
                $feed_cats = $item->get_categories();
                if(is_array($feed_cats) && count($feed_cats) > 0)
                {
                    foreach ($feed_cats as $category)
                    {
                        $extra_categories .= $category->get_label() . ',';
                    }
                    $extra_categories = trim($extra_categories, ',');
                }
                $my_post                          = array();
                $my_post['rfpge_enable_pingbacks'] = $enable_pingback;
                $my_post['post_type']             = sanitize_text_field($post_type);
                $my_post['comment_status']        = sanitize_text_field($accept_comments);
                if (isset($echo_Main_Settings['draft_first']) && $echo_Main_Settings['draft_first'] == 'on')
                {
                    if($post_status == 'publish')
                    {
                        $draft_me = true;
                        $my_post['post_status'] = 'draft';
                    }
                    else
                    {
                        $my_post['post_status']   = sanitize_text_field($post_status);
                    }
                }
                else
                {
                    $my_post['post_status'] = sanitize_text_field($post_status);
                }
                
                $my_post['post_author']           = sanitize_text_field($post_user_name);
                $item_tags = '';
                if(is_array($feed_cats) && count($feed_cats) > 0)
                {
                    foreach ($feed_cats as $category)
                    {
                        $item_tags .= $category->get_label() . ',';
                    }
                    $item_tags = trim($item_tags, ',');
                }
                if ($can_create_tag == '1') {
                    $my_post['tags_input'] = sanitize_text_field(($item_create_tag != '' ? $item_create_tag . ',' : '') . $item_tags);
                } else if ($item_create_tag != '') {
                    $my_post['tags_input'] = sanitize_text_field($item_create_tag);
                }
                $orig_content = '';
                $my_post['rfpge_post_url']  = sanitize_text_field($url);
                $my_post['rfpge_post_date'] = sanitize_text_field($date);
                if ($full_content == '1') {
                    $exp_content = rfpge_get_full_content($url, $type, stripcslashes(htmlspecialchars_decode($expre)), $only_text, $single, $inner, $get_css, $encoding);
                    if ($exp_content !== FALSE && $exp_content != '') {
                        $orig_content = $content;
                        $content = $exp_content;
                    }
                }
                $get_img = '';
                $img_found = false;
                $get_img = rfpge_get_featured_image($url, $content, $item, $orig_content, $skip_og, $skip_feed_image, $skip_first_img, $skip_post_content);
                if($get_img != '')
                {
                    $img_found = true;
                    if(substr($get_img, 0, 1) === "/")
                    {
                        $get_img = preg_replace('{\/(.*)}', rfpge_get_url_domain($url) . '/$1', $get_img);
                    }
                }
                $content = preg_replace('{"\/(.+?)"}', '"' . rfpge_get_url_domain($url) . '/$1"', $content);
                if (isset($echo_Main_Settings['skip_image_names']) && $echo_Main_Settings['skip_image_names'] != '' && $img_found == true) 
                {
                    $need_to_continue = false;
                    $skip_images = explode(',', $echo_Main_Settings['skip_image_names']);
                    foreach($skip_images as $ski)
                    {
                        if(rfpge_stringMatchWithWildcard($get_img, trim($ski)))
                        {
                            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                                rfpge_log_to_file('Skipping post "' . $title . '", because it has excluded image name: ' . $get_img . ' - ' . $ski);
                            }
                            $need_to_continue = true;
                            break;
                        }
                    }
                    if($need_to_continue == true)
                    {
                        continue;
                    }
                }
                if (isset($echo_Main_Settings['skip_no_img']) && $echo_Main_Settings['skip_no_img'] == 'on' && $img_found == false) {
                    if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                        rfpge_log_to_file('Skipping post "' . $title . '", because it has no detected image file attached');
                    }
                    continue;
                }
                $my_post['rfpge_post_image']       = $get_img;
                if ($strip_by_id != '') {
                    if(!class_exists('rfpge_html_dom_simple_html_dom_node'))
                    {
                        require_once (dirname(__FILE__) . "/res/simple_html_dom.php");
                    }
                    $strip_list = explode(',', $strip_by_id);
                    $html_dom_original_html = html_dom_str_get_html($content);
                    if(method_exists($html_dom_original_html, 'find')){
                        foreach ($strip_list as $strip_id) {
                            $ret = $html_dom_original_html->find('*[id="'.trim($strip_id).'"]');
                            foreach ($ret as $itm ) {
                                $itm->outertext = '' ;
                            }
                        }
                        $content = $html_dom_original_html->save();
                        $html_dom_original_html->clear();
                        unset($html_dom_original_html);
                    }else{
                        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                            rfpge_log_to_file('Error in html_dom_str_get_html, returned unknown structure');
                        }
                    }
                }
                if ($strip_by_class != '') {
                    if(!class_exists('rfpge_html_dom_simple_html_dom_node'))
                    {
                        require_once (dirname(__FILE__) . "/res/simple_html_dom.php");
                    }
                    $strip_list = explode(',', $strip_by_class);
                    $html_dom_original_html = html_dom_str_get_html($content);
                    if(method_exists($html_dom_original_html, 'find')){
                        foreach ($strip_list as $strip_class) {
                            $ret = $html_dom_original_html->find('*[class="'.trim($strip_class).'"]');
                            foreach ($ret as $itm ) {
                                $itm->outertext = '' ;
                            }
                        }
                        $content = $html_dom_original_html->save();
                        $html_dom_original_html->clear();
                        unset($html_dom_original_html);
                    }else{
                        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                            rfpge_log_to_file('Error in html_dom_str_get_html, returned unknown structure');
                        }
                    }
                } 
                $postdate = strtotime($date);
                if($postdate !== FALSE)
                {
                    $postdate = gmdate("Y-m-d H:i:s", intval($postdate));
                }
                if($import_date == '1')
                {
                    if($postdate !== FALSE)
                    {
                        $my_post['post_date'] = $postdate;
                    }
                }
                if($postdate === false)
                {
                    $postdate = $date;
                }
                if($content_percent != '' && is_numeric($content_percent))
                {
                    $temp_t = rfpge_strip_html_tags($content);
                    $temp_t = str_replace('&nbsp;',"",$temp_t);
                    $ccount = str_word_count($temp_t);
                    if($ccount > 10)
                    {
                        $str_count = strlen($content);
                        $leave_cont = round($str_count * $content_percent / 100);
                        $content = rfpge_substr_close_tags($content, $leave_cont);
                    }
                }
                $spintax = new Echo_Spintax();
                $post_title = $spintax->process($post_title);
                $post_content = $spintax->process($post_content);
                
                if (strpos($post_content, '%%') !== false) {
                    $new_post_content = rfpge_replaceContentShortcodes($post_content, $title, $content, $url, $extra_categories, $item_tags, $get_img, $feed_title, $feed_description, $description, $feed_logo, $author, $author_link, $author_email, $read_more, $postdate);
                } else {
                    $new_post_content = $post_content;
                }
                if (strpos($post_title, '%%') !== false) {
                    $new_post_title = rfpge_replaceTitleShortcodes($post_title, $title, $content, $url, $extra_categories, $item_tags);
                } else {
                    $new_post_title = $post_title;
                }
                $my_post['extra_categories'] = sanitize_text_field($extra_categories);
                $my_post['extra_tags']       = sanitize_text_field($item_tags);
                $my_post['feed_title']       = sanitize_text_field($feed_title);
                $my_post['feed_description'] = sanitize_text_field($feed_description);
                $my_post['description']      = sanitize_text_field($description);
                $my_post['feed_logo']        = sanitize_text_field($feed_logo);
                $my_post['author']           = sanitize_user($author);
                $my_post['author_link']      = sanitize_text_field($author_link);
                $my_post['author_email']     = sanitize_email($author_email);
                $arr                         = rfpge_spin_and_translate($new_post_title, $new_post_content, $translate, $source_lang);
                $new_post_title              = $arr[0];
                $new_post_content            = $arr[1];
                $new_post_title              = html_entity_decode($new_post_title);
                $new_post_content            = html_entity_decode($new_post_content);
                $title_count = -1;
                if (isset($echo_Main_Settings['min_word_title']) && $echo_Main_Settings['min_word_title'] != '') {
                    $title_count = str_word_count($new_post_title);
                    if ($title_count < intval($echo_Main_Settings['min_word_title'])) {
                        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                            rfpge_log_to_file('Skipping post "' . $new_post_title . '", because title lenght (' . $title_count . ') < ' . $echo_Main_Settings['min_word_title']);
                        }
                        continue;
                    }
                }
                if (isset($echo_Main_Settings['max_word_title']) && $echo_Main_Settings['max_word_title'] != '') {
                    if ($title_count == -1) {
                        $title_count = str_word_count($new_post_title);
                    }
                    if ($title_count > intval($echo_Main_Settings['max_word_title'])) {
                        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                            rfpge_log_to_file('Skipping post "' . $new_post_title . '", because title lenght (' . $title_count . ') > ' . $echo_Main_Settings['max_word_title']);
                        }
                        continue;
                    }
                }
                $content_count = -1;
                if (isset($echo_Main_Settings['min_word_content']) && $echo_Main_Settings['min_word_content'] != '') {
                    $content_count = str_word_count(rfpge_strip_html_tags($new_post_content));
                    if ($content_count < intval($echo_Main_Settings['min_word_content'])) {
                        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                            rfpge_log_to_file('Skipping post "' . $new_post_title . '", because content lenght (' . $content_count . ') < ' . $echo_Main_Settings['min_word_content']);
                        }
                        continue;
                    }
                }
                if (isset($echo_Main_Settings['max_word_content']) && $echo_Main_Settings['max_word_content'] != '') {
                    if ($content_count == -1) {
                        $content_count = str_word_count(rfpge_strip_html_tags($new_post_content));
                    }
                    if ($content_count > intval($echo_Main_Settings['max_word_content'])) {
                        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                            rfpge_log_to_file('Skipping post "' . $new_post_title . '", because content lenght (' . $content_count . ') > ' . $echo_Main_Settings['max_word_content']);
                        }
                        continue;
                    }
                }
                if ($banned_words != '') {
                    $continue    = false;
                    $banned_list = explode(',', $banned_words);
                    foreach ($banned_list as $banned_word) {
                        if (stripos($new_post_content, trim($banned_word)) !== FALSE) {
                            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                                rfpge_log_to_file('Skipping post "' . $new_post_title . '", because it\'s content contains banned word: ' . $banned_word);
                            }
                            $continue = true;
                            break;
                        }
                        if (stripos($new_post_title, trim($banned_word)) !== FALSE) {
                            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                                rfpge_log_to_file('Skipping post "' . $new_post_title . '", because it\'s title contains banned word: ' . $banned_word);
                            }
                            $continue = true;
                            break;
                        }
                    }
                    if ($continue === true) {
                        continue;
                    }
                }
                if(isset($echo_Main_Settings['global_ban_words']) && $echo_Main_Settings['global_ban_words'] != '') {
                    $continue    = false;
                    $banned_list = explode(',', $echo_Main_Settings['global_ban_words']);
                    foreach ($banned_list as $banned_word) {
                        if (stripos($new_post_content, trim($banned_word)) !== FALSE) {
                            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                                rfpge_log_to_file('Skipping post "' . $new_post_title . '", because it\'s content contains global banned word: ' . $banned_word);
                            }
                            $continue = true;
                            break;
                        }
                        if (stripos($new_post_title, trim($banned_word)) !== FALSE) {
                            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                                rfpge_log_to_file('Skipping post "' . $new_post_title . '", because it\'s title contains global banned word: ' . $banned_word);
                            }
                            $continue = true;
                            break;
                        }
                    }
                    if ($continue === true) {
                        continue;
                    }
                }
                if(isset($echo_Main_Settings['global_req_words']) && $echo_Main_Settings['global_req_words'] != '')
                {
                    if(isset($echo_Main_Settings['require_only_one']) && $echo_Main_Settings['require_only_one'] == 'on')
                    {
                        $continue      = true;
                        $required_list = explode(',', $echo_Main_Settings['global_req_words']);
                        foreach ($required_list as $required_word) {
                            if (stripos($new_post_content, trim($required_word)) !== FALSE || stripos($new_post_title, trim($required_word)) !== FALSE) {
                                $continue = false;
                                break;
                            }
                        }
                        if ($continue === true) {
                            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                                rfpge_log_to_file('Skipping post "' . $new_post_title . '", because it\'s content doesn\'t contain global required words.');
                            }
                            continue;
                        }
                    }
                    else
                    {
                        $continue      = false;
                        $required_list = explode(',', $echo_Main_Settings['global_req_words']);
                        foreach ($required_list as $required_word) {
                            if (stripos($new_post_content, trim($required_word)) === FALSE && stripos($new_post_title, trim($required_word)) === FALSE) {
                                $continue = true;
                                break;
                            }
                        }
                        if ($continue === true) {
                            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                                rfpge_log_to_file('Skipping post "' . $new_post_title . '", because it\'s content doesn\'t contain global required words.');
                            }
                            continue;
                        }
                    }
                }
                if ($required_words != '') {
                    $continue      = false;
                    $required_list = explode(',', $required_words);
                    foreach ($required_list as $required_word) {
                        if (stripos($new_post_content, trim($required_word)) === FALSE && stripos($new_post_title, trim($required_word)) === FALSE) {
                            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                                rfpge_log_to_file('Skipping post "' . $new_post_title . '", because it\'s content doesn\'t contain required word: ' . $required_word);
                            }
                            $continue = true;
                            break;
                        }
                    }
                    if ($continue === true) {
                        continue;
                    }
                }
                if (isset($echo_Main_Settings['strip_links']) && $echo_Main_Settings['strip_links'] == 'on') {
                    $new_post_content = rfpge_strip_links($new_post_content);
                }
                if (isset($echo_Main_Settings['replace_url']) && $echo_Main_Settings['replace_url'] !== '') {
                    $new_post_content = preg_replace('/<a(.+?)href=["\']([^"\']+?)["\']([^>]+?)>/i','<a$1href="' . $echo_Main_Settings['replace_url'] . '"$3>', $new_post_content);
                }
                if ($strip_images == '1') {
                    $new_post_content = rfpge_strip_images($new_post_content);
                }
                if ($limit_word_count !== "") {
                    $new_post_content = rfpge_custom_wp_trim_excerpt($new_post_content, $limit_word_count, $url, $read_more);
                }
                
                if (isset($echo_Main_Settings['copy_images']) && $echo_Main_Settings['copy_images'] == 'on') {
                    preg_match_all('/(http|https|ftp|ftps)?:\/\/\S+\.(?:jpg|png|gif)/', $new_post_content, $matches);
                    if(isset($matches[0][0]))
                    {
                        foreach($matches[0] as $match)
                        {
                            $file_path = rfpge_copy_image_locally($match);
                            if($file_path != false)
                            {
                                $file_path = str_replace('\\', '/', $file_path);
                                $new_post_content = str_replace($match, $file_path, $new_post_content);
                            }
                        }
                    }
                }
                if ((isset($echo_Main_Settings['link_attributes_internal']) && $echo_Main_Settings['link_attributes_internal'] !== '') || (isset($echo_Main_Settings['link_attributes_external']) && $echo_Main_Settings['link_attributes_external'] !== ''))
                {
                    $new_post_content = rfpge_add_link_tags($new_post_content);
                }
                if ((isset($echo_Main_Settings['link_append']) && $echo_Main_Settings['link_append'] !== ''))
                {
                    $new_post_content = rfpge_append_link_strings($new_post_content, $echo_Main_Settings['link_append']);
                }
                if (isset($echo_Main_Settings['iframe_resize_width']) && $echo_Main_Settings['iframe_resize_width'] !== '')
                {
                    $new_post_content = preg_replace("~<iframe(.*?)(?:width=[\"\'](?:\d*?)[\"\'])?(.*?)>~i", '<iframe$1 width="' . $echo_Main_Settings['iframe_resize_width'] . '"$2>', $new_post_content); 
                }
                if (isset($echo_Main_Settings['iframe_resize_height']) && $echo_Main_Settings['iframe_resize_height'] !== '')
                {
                    $new_post_content = preg_replace("~<iframe(.*?)(?:height=[\"\'](?:\d*?)[\"\'])?(.*?)>~i", '<iframe$1 height="' . $echo_Main_Settings['iframe_resize_height'] . '"$2>', $new_post_content); 
                }
                if ($strip_by_regex !== '')
                {
                    $temp_cont = preg_replace("~" . $strip_by_regex . "~i", $replace_regex, $new_post_content);
                    if($temp_cont !== NULL)
                    {
                        $new_post_content = $temp_cont;
                    }
                }
                $exc_cont = $content;
                if ($strip_by_regex !== '')
                {
                    $temp_cont = preg_replace("~" . $strip_by_regex . "~i", $replace_regex, $exc_cont);
                    if($temp_cont !== NULL)
                    {
                        $exc_cont = $temp_cont;
                    }
                }
                $new_post_content = str_replace('</ iframe>', '</iframe>', $new_post_content);
                if ($img_found == true && isset($echo_Main_Settings['strip_featured_image']) && $echo_Main_Settings['strip_featured_image'] == 'on') {
                    $new_post_content = str_replace($get_img, '', $new_post_content);
                }
                $my_post['post_content'] = $new_post_content;
                if (isset($echo_Main_Settings['disable_excerpt']) && $echo_Main_Settings['disable_excerpt'] == "on") {
                    $my_post['post_excerpt'] = '';
                }
                else
                {
                    if (isset($echo_Main_Settings['excerpt_length']) && is_numeric($echo_Main_Settings['excerpt_length'])) {
                        $words = $echo_Main_Settings['excerpt_length'];
                    }
                    else
                    {
                        $words = 55;
                    }
                    if ($translate != "disabled" && $translate != "en") {
                        $my_post['post_excerpt'] = rfpge_getExcerpt($new_post_content, $words);
                    } else {
                        $my_post['post_excerpt'] = rfpge_getExcerpt($exc_cont, $words);
                    }
                }
                $my_post['auto_delete'] = '';
                if ($auto_delete !== "") {
                    $del_time = strtotime($auto_delete);
                    if($del_time !== false)
                    {
                        $my_post['auto_delete'] = $del_time;
                    }
                }
                $my_post['post_title']       = sanitize_text_field($new_post_title);
                
                $my_post['original_title']   = sanitize_text_field($title);
                $my_post['original_content'] = $content;
                $my_post['rfpge_source_feed'] = $feed_uri;
                $my_post['rfpge_timestamp']   = rfpge_get_date_now();
                $my_post['rfpge_post_format'] = sanitize_text_field($post_format);
                if ($enable_pingback == '1') {
                    $my_post['ping_status'] = 'open';
                } else {
                    $my_post['ping_status'] = 'closed';
                }
                $custom_arr = array();
                if($custom_fields != '')
                {
                    if(stristr($custom_fields, '=>') != false)
                    {
                        $rule_arr = explode(',', trim($custom_fields));
                        foreach($rule_arr as $rule)
                        {
                            $my_args = explode('=>', trim($rule));
                            if(isset($my_args[1]))
                            {
                                $custom_field_content = trim($my_args[1]);
                                $custom_field_content = rfpge_replaceContentShortcodes($custom_field_content, $title, $content, $url, $extra_categories, $item_tags, $get_img, $feed_title, $feed_description, $description, $feed_logo, $author, $author_link, $author_email, $read_more, $postdate);
                                $custom_arr[trim($my_args[0])] = $custom_field_content;
                            }
                        }
                    }
                }
                $custom_arr = array_merge($custom_arr, array('rfpge_featured_image' => $get_img));
                $my_post['meta_input'] = sanitize_text_field($custom_arr);
                $post_array[] = $my_post;
                $count++;
            }
            $items = null;
            unset($items);
            $posted_items = null;
            unset($posted_items);
            $post_array = array_reverse($post_array);
            foreach ($post_array as $post) {
                remove_filter('content_save_pre', 'wp_filter_post_kses');
                remove_filter('content_filtered_save_pre', 'wp_filter_post_kses');
                $post_id = wp_insert_post($post, true);
                add_filter('content_save_pre', 'wp_filter_post_kses');
                add_filter('content_filtered_save_pre', 'wp_filter_post_kses');
                if (!is_wp_error($post_id)) {
                    $posts_inserted++;
                    if (isset($my_post['rfpge_post_format']) && $my_post['rfpge_post_format'] != '' && $my_post['rfpge_post_format'] != 'post-format-standard') {
                        wp_set_post_terms($post_id, $my_post['rfpge_post_format'], 'post_format');
                    }
                    $featured_path = '';
                    $image_failed  = false;
                    if ($featured_image == '1') {
                        $get_img = $post['rfpge_post_image'];
                        if ($get_img != '') {
                            if (!rfpge_generate_featured_image($get_img, $post_id)) {
                                $image_failed = true;
                                if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                                    rfpge_log_to_file('rfpge_generate_featured_image failed for ' . $get_img . '!');
                                }
                            } else {
                                $featured_path = $get_img;
                                if ( ! add_post_meta( $post_id, 'rfpge_featured_image', $featured_path, true ) ) { 
                                   update_post_meta( $post_id, 'rfpge_featured_image', $featured_path );
                                }
                            }
                        } else {
                            $image_failed = true;
                        }
                    }
                    if ($image_failed || $featured_image !== '1') {
                        if ($image_url != '') {
                            if (!rfpge_generate_featured_image($image_url, $post_id)) {
                                $image_failed = true;
                                if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                                    rfpge_log_to_file('rfpge_generate_featured_image failed to deafault value: ' . $image_url . '!');
                                }
                            } else {
                                $featured_path = $image_url;
                                if ( ! add_post_meta( $post_id, 'rfpge_featured_image', $featured_path, true ) ) { 
                                   update_post_meta( $post_id, 'rfpge_featured_image', $featured_path );
                                }
                                wp_suspend_cache_addition(true);
                                $url =  get_post_meta( $post_id, 'rfpge_featured_image', TRUE );
                                wp_suspend_cache_addition(false);
                            }
                        }
                    }
                    if($remove_default == '1' && ($auto_categories == '1' || (isset($default_category) && $default_category !== 'rfpge_no_category_12345678' && $default_category[0] !== 'rfpge_no_category_12345678')))
                    {
                        $default_categories = wp_get_post_categories($post_id);
                    }
                    if ($auto_categories == '1') {
                        if (isset($echo_Main_Settings['new_category']) && $echo_Main_Settings['new_category'] == 'on') 
                        {
                            if ($post['extra_categories'] != '') {
                                $titler = $post['extra_categories'];
                                $titler = array_map('trim', explode(',', $titler));
                            }
                            else
                            {
                                $keyword_class = new Echo_keywords();
                                $titler = $keyword_class->keywords($post['post_title'], 2);
                                $titler = explode(' ', $titler);
                            }
                            $blog_cats = rfpge_my_list_cats();
                            $blog_cats = array_map('strtolower', $blog_cats);
                            $title_words = '';
                            foreach($titler as $t)
                            {
                                if(in_array(strtolower($t), $blog_cats))
                                {
                                    $title_words .= $t . ',';
                                }
                            }
                            $title_words = trim($title_words, ',');
                            if($title_words != '')
                            {
                                $termid = rfpge_create_terms('category', '0', $title_words, $remove_cats);
                                wp_set_post_terms($post_id, $termid, 'category', true);
                            }
                        }
                        else
                        {
                            if ($post['extra_categories'] != '') {
                                $termid = rfpge_create_terms('category', '0', $post['extra_categories'], $remove_cats);
                                wp_set_post_terms($post_id, $termid, 'category', true);
                            }
                            else
                            {
                                $keyword_class = new Echo_keywords();
                                $titler = $keyword_class->keywords($post['post_title'], 2);
                                $titler = str_replace(' ', ',', $titler);
                                $termid = rfpge_create_terms('category', '0', $titler, $remove_cats);
                                wp_set_post_terms($post_id, $termid, 'category', true);
                            }
                        }
                    }
                    if (isset($default_category) && $default_category !== 'rfpge_no_category_12345678' && $default_category[0] !== 'rfpge_no_category_12345678') {
                        if(is_array($default_category))
                        {
                            $cats   = array();
                            foreach($default_category as $dc)
                            {
                                $cats[] = $dc;
                            }
                            wp_set_post_categories($post_id, $cats, true);
                        }
                        else
                        {
                            $cats   = array();
                            $cats[] = $default_category;
                            wp_set_post_categories($post_id, $cats, true);
                        }
                    }
                    if($remove_default == '1' && ($auto_categories == '1' || (isset($default_category) && $default_category !== 'rfpge_no_category_12345678' && $default_category[0] !== 'rfpge_no_category_12345678')))
                    {
                        $new_categories = wp_get_post_categories($post_id);
                        if(isset($default_categories) && !($default_categories == $new_categories))
                        {
                            foreach($default_categories as $dc)
                            {
                                $rem_cat = get_category( $dc );
                                wp_remove_object_terms( $post_id, $rem_cat->slug, 'category' );
                            }
                        }
                    }
                    $tax_rez = wp_set_object_terms( $post_id, 'Echo_' . $param, 'coderevolution_post_source');
                    if (is_wp_error($tax_rez)) {
                        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                            rfpge_log_to_file('wp_set_object_terms failed for: ' . $post_id . '!');
                        }
                    }
                    if (isset($echo_Main_Settings['link_source']) && $echo_Main_Settings['link_source'] == 'on') {
                        $title_link_url = '1';
                    }
                    else
                    {
                        $title_link_url = '0';
                    }
                    rfpge_addPostMeta($post_id, $post, $param, $featured_path, $title_link_url);
                    if (isset($echo_Main_Settings['draft_first']) && $echo_Main_Settings['draft_first'] == 'on' && $draft_me == true)
                    {
                        rfpge_change_post_status($post_id, 'publish');
                    }
                    
                } else {
                    rfpge_log_to_file('Failed to insert post into database! Title:' . $post['post_title'] . '! Error: ' . $post_id->get_error_message() . 'Error code: ' . $post_id->get_error_code() . 'Error data: ' . $post_id->get_error_data());
                    continue;
                }
            }
            $post_array = null;
            unset($post_array);
        }
        catch (Exception $e) {
            if(isset($post_array))
            {
                $post_array = null;
                unset($post_array);
            }
            rfpge_log_to_file('Exception thrown ' . $e . '!');
            if($auto == 1)
            {
                rfpge_clearFromList($param);
            }
            return 'fail';
        }
        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
            rfpge_log_to_file('Rule ID ' . $param . ' succesfully run! ' . $posts_inserted . ' posts created!');
        }
        if (isset($echo_Main_Settings['send_email']) && $echo_Main_Settings['send_email'] == 'on' && $echo_Main_Settings['email_address'] !== '') {
            try {
                $to        = $echo_Main_Settings['email_address'];
                if (!filter_var($to, FILTER_VALIDATE_EMAIL) === false)
                {
                    $subject   = '[Echo] Rule running report - ' . rfpge_get_date_now();
                    $message   = 'Rule ID ' . $param . ' succesfully run! ' . $posts_inserted . ' posts created!';
                    $headers[] = 'From: Echo Plugin <echo@noreply.net>';
                    $headers[] = 'Reply-To: noreply@echo.com';
                    $headers[] = 'X-Mailer: PHP/' . phpversion();
                    $headers[] = 'Content-Type: text/html';
                    $headers[] = 'Charset: ' . get_option('blog_charset', 'UTF-8');
                    wp_mail($to, $subject, $message, $headers);
                }
            }
            catch (Exception $e) {
                if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                    rfpge_log_to_file('Failed to send mail: Exception thrown ' . $e . '!');
                }
            }
        }
    }
    if ($posts_inserted == 0) {
        if($auto == 1)
        {
            rfpge_clearFromList($param);
        }
        return 'nochange';
    } else {
        if($auto == 1)
        {
            rfpge_clearFromList($param);
        }
        return 'ok';
    }
}
function rfpge_change_post_status($post_id, $status){
    $current_post = get_post( $post_id, 'ARRAY_A' );
    $current_post['post_status'] = $status;
    remove_filter('content_save_pre', 'wp_filter_post_kses');
    remove_filter('content_filtered_save_pre', 'wp_filter_post_kses');
    wp_update_post($current_post);
    add_filter('content_save_pre', 'wp_filter_post_kses');
    add_filter('content_filtered_save_pre', 'wp_filter_post_kses');
}
function rfpge_stringMatchWithWildcard($source, $pattern) {
    $pattern = preg_quote($pattern,'/');        
    $pattern = str_replace( '\*' , '.*', $pattern);   
    return preg_match( '~' . $pattern . '~i' , $source );
}

function rfpge_add_link_tags($content) {
    $content = stripslashes(preg_replace_callback('~<(a\s[^>]+)>~isU', "rfpge_link_callback", preg_quote($content)));
    return $content;
}

function rfpge_append_link_strings($content, $append) {
    $content = preg_replace('`((?:http|ftp|https):\/\/(?:[\w_-]+(?:(?:\.[\w_-]+)+))(?:[\w.,@?^=%&:/~+#-]*[\w@?^=%&/~+#-])?)`i','$1' . $append . '', $content);
    return $content;
}

function rfpge_link_callback($match) { 
    list($original, $tag) = $match;
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    $blog_url = get_home_url();
    $disallowed = array('http://', 'https://', 'www.');
    foreach($disallowed as $d) {
       $blog_url = str_replace($d, '', $blog_url);
    }
    if (stripos($tag, $blog_url) !== false) {
        if (isset($echo_Main_Settings['link_attributes_internal']) && $echo_Main_Settings['link_attributes_internal'] != '') {
            return "<$tag " . $echo_Main_Settings['link_attributes_internal'] . ">";
        }
    }
    else {
        if (isset($echo_Main_Settings['link_attributes_external']) && $echo_Main_Settings['link_attributes_external'] != '') {
            return "<$tag " . $echo_Main_Settings['link_attributes_external'] . ">";
        }
    }
    return $original;
}

$rfpge_fatal = false;
function rfpge_clear_flag_at_shutdown($param)
{
    $error = error_get_last();
    if ($error['type'] === E_ERROR && $GLOBALS['rfpge_fatal'] === false) {
        $GLOBALS['rfpge_fatal'] = true;
        $running = array();
        update_option('rfpge_running_list', $running);
        rfpge_log_to_file('[FATAL] Exit error: ' . $error['message'] . ', file: ' . $error['file'] . ', line: ' . $error['line'] . '!');
    }
    else
    {
        rfpge_clearFromList($param);
    }
}

function rfpge_strip_images($content)
{
    $content = preg_replace("/<img[^>]+\>/i", "", $content); 
    return $content;
}
function rfpge_get_url_domain($url) {
  $result = parse_url($url);
  return $result['scheme']."://".$result['host'];
}
function rfpge_strip_links($content)
{
    $content = preg_replace('/<a([^>]*)href=(\"|\')(.*?)(\"|\')([^>]*)>(.*?)<\/a>/', "\\6", $content);
    return $content;
}

add_filter('the_title', 'rfpge_add_affiliate_title_keyword');
function rfpge_add_affiliate_title_keyword($content)
{
    $rules  = get_option('rfpge_keyword_list');
    $output = '';
    if (!empty($rules)) {
        foreach ($rules as $request => $value) {
            if(isset($value[2]) && $value[2] == 'content')
            {
                continue;
            }
            if (is_array($value) && isset($value[1])) {
                $repl = $value[1];
            } else {
                $repl = $request;
            }
            if (isset($value[0]) && $value[0] != '') {
                $content = preg_replace('\'(?!((<.*?)|(<a.*?)))(' . preg_quote($request) . ')(?!(([^<>]*?)>)|([^>]*?<\/a>))\'i', '<a href="' . $value[0] . '" target="_blank">' . $repl . '</a>', $content);
            } else {
                $content = preg_replace('#(?!((<.*?)|(<a.*?)))(' . preg_quote($request) . ')(?!(([^<>]*?)>)|([^>]*?<\/a>))#i', $repl, $content);
            }
        }
    }
    return $content;
}
add_filter('the_content', 'rfpge_add_affiliate_content_keyword');
function rfpge_add_affiliate_content_keyword($content)
{
    $rules  = get_option('rfpge_keyword_list');
    $output = '';
    if (!empty($rules)) {
        foreach ($rules as $request => $value) {
            if(isset($value[2]) && $value[2] == 'title')
            {
                continue;
            }
            if (is_array($value) && isset($value[1]) && $value[1] != '') {
                $repl = $value[1];
            } else {
                $repl = $request;
            }
            if (isset($value[0]) && $value[0] != '') {
                $content = preg_replace('\'(?!((<.*?)|(<a.*?)))(' . preg_quote($request) . ')(?!(([^<>]*?)>)|([^>]*?<\/a>))\'i', '<a href="' . $value[0] . '" target="_blank">' . $repl . '</a>', $content);
            } else {
                $content = preg_replace('\'(?!((<.*?)|(<a.*?)))(' . preg_quote($request) . ')(?!(([^<>]*?)>)|([^>]*?<\/a>))\'i', $repl, $content);
            }
        }
    }
    return $content;
}

function rfpge_meta_box_function($post)
{
    wp_suspend_cache_addition(true);
    $index                 = get_post_meta($post->ID, 'rfpge_parent_rule', true);
    $title                 = get_post_meta($post->ID, 'rfpge_item_title', true);
    $cats                  = get_post_meta($post->ID, 'rfpge_extra_categories', true);
    $tags                  = get_post_meta($post->ID, 'rfpge_extra_tags', true);
    $img                   = get_post_meta($post->ID, 'rfpge_featured_img', true);
    $post_img              = get_post_meta($post->ID, 'rfpge_post_img', true);
    $rfpge_source_feed      = get_post_meta($post->ID, 'rfpge_source_feed', true);
    $rfpge_timestamp        = get_post_meta($post->ID, 'rfpge_timestamp', true);
    $rfpge_post_date        = get_post_meta($post->ID, 'rfpge_post_date', true);
    $rfpge_post_url         = get_post_meta($post->ID, 'rfpge_post_url', true);
    $rfpge_enable_pingbacks = get_post_meta($post->ID, 'rfpge_enable_pingbacks', true);
    $rfpge_comment_status   = get_post_meta($post->ID, 'rfpge_comment_status', true);
    $rfpge_feed_title       = get_post_meta($post->ID, 'rfpge_feed_title', true);
    $rfpge_feed_description = get_post_meta($post->ID, 'rfpge_feed_description', true);
    $feed_logo             = get_post_meta($post->ID, 'feed_logo', true);
    $rfpge_author           = get_post_meta($post->ID, 'rfpge_author', true);
    $rfpge_author_link      = get_post_meta($post->ID, 'rfpge_author_link', true);
    $rfpge_author_email     = get_post_meta($post->ID, 'rfpge_author_email', true);
    $rfpge_delete_time      = get_post_meta($post->ID, 'rfpge_delete_time', true);
    
    if (isset($index) && $index != '') {
        $ech = '<table style="display: block;overflow: auto;"><tr><td><b>Post Parent Rule:</b></td><td>&nbsp;' . $index . '</td></tr>';
        $ech .= '<tr><td><b>Post Original Title:</b></td><td>&nbsp;' . $title . '</td></tr>';
        if ($rfpge_feed_title != '') {
            $ech .= '<tr><td><b>Parent Feed Title:</b></td><td>&nbsp;' . $rfpge_feed_title . '</td></tr>';
        }
        if ($rfpge_feed_description != '') {
            $ech .= '<tr><td><b>Parent Feed Description:</b></td><td>&nbsp;' . $rfpge_feed_description . '</td></tr>';
        }
        if ($feed_logo != '') {
            $ech .= '<tr><td><b>Parent Feed Logo:</b></td><td>&nbsp;' . $feed_logo . '</td></tr>';
        }
        if ($rfpge_author != '') {
            $ech .= '<tr><td><b>Parent Feed Author:</b></td><td>&nbsp;' . $rfpge_author . '</td></tr>';
        }
        if ($rfpge_author_link != '') {
            $ech .= '<tr><td><b>Parent Feed Author URL:</b></td><td>&nbsp;' . $rfpge_author_link . '</td></tr>';
        }
        if ($rfpge_author_email != '') {
            $ech .= '<tr><td><b>Parent Feed Author Email:</b></td><td>&nbsp;' . $rfpge_author_email . '</td></tr>';
        }
        if ($rfpge_timestamp != '') {
            $ech .= '<tr><td><b>Post Creation Date:</b></td><td>&nbsp;' . $rfpge_timestamp . '</td></tr>';
        }
        if ($cats != '') {
            $ech .= '<tr><td><b>Post Categories:</b></td><td>&nbsp;' . $cats . '</td></tr>';
        }
        if ($tags != '') {
            $ech .= '<tr><td><b>Post Tags:</b></td><td>&nbsp;' . $tags . '</td></tr>';
        }
        if ($img != '') {
            $ech .= '<tr><td><b>Featured Image:</b></td><td>&nbsp;' . $img . '</td></tr>';
        }
        if ($post_img != '') {
            $ech .= '<tr><td><b>Post Image:</b></td><td>&nbsp;' . $post_img . '</td></tr>';
        }
        if ($rfpge_source_feed != '') {
            $ech .= '<tr><td><b>Source Feed:</b></td><td>&nbsp;' . $rfpge_source_feed . '</td></tr>';
        }
        if ($rfpge_post_date != '') {
            $ech .= '<tr><td><b>Item Source URL Date:</b></td><td>&nbsp;' . $rfpge_post_date . '</td></tr>';
        }
        if ($rfpge_post_url != '') {
            $ech .= '<tr><td><b>Item Source URL:</b></td><td>&nbsp;' . $rfpge_post_url . '</td></tr>';
        }
        if ($rfpge_enable_pingbacks != '') {
            $ech .= '<tr><td><b>Pingback/Trackback Status:</b></td><td>&nbsp;' . $rfpge_enable_pingbacks . '</td></tr>';
        }
        if ($rfpge_comment_status != '') {
            $ech .= '<tr><td><b>Comment Status:</b></td><td>&nbsp;' . $rfpge_comment_status . '</td></tr>';
        }
        if ($rfpge_comment_status != '') {
            $ech .= '<tr><td><b>Auto Delete Post:</b></td><td>&nbsp;' . gmdate("Y-m-d H:i:s", intval($rfpge_delete_time)) . '</td></tr>';
        }
        $ech .= '</table><br/>';
    } else {
        $ech = 'This is not an automatically generated post.';
    }
    echo $ech;
    wp_suspend_cache_addition(false);
}

function rfpge_addPostMeta($post_id, $post, $param, $featured_img, $title_url = 0)
{
    add_post_meta($post_id, 'rfpge_parent_rule', $param);
    add_post_meta($post_id, 'rfpge_enable_pingbacks', $post['rfpge_enable_pingbacks']);
    add_post_meta($post_id, 'rfpge_comment_status', $post['comment_status']);
    add_post_meta($post_id, 'rfpge_item_title', $post['original_title']);
    add_post_meta($post_id, 'rfpge_extra_categories', $post['extra_categories']);
    add_post_meta($post_id, 'rfpge_extra_tags', $post['extra_tags']);
    add_post_meta($post_id, 'rfpge_post_img', $post['rfpge_post_image']);
    add_post_meta($post_id, 'rfpge_featured_img', $featured_img);
    add_post_meta($post_id, 'rfpge_source_feed', $post['rfpge_source_feed']);
    add_post_meta($post_id, 'rfpge_timestamp', $post['rfpge_timestamp']);
    add_post_meta($post_id, 'rfpge_post_url', $post['rfpge_post_url']);
    add_post_meta($post_id, 'rfpge_post_date', $post['rfpge_post_date']);
    add_post_meta($post_id, 'rfpge_feed_title', $post['feed_title']);
    add_post_meta($post_id, 'rfpge_feed_description', $post['feed_description']);
    add_post_meta($post_id, 'feed_logo', $post['feed_logo']);
    add_post_meta($post_id, 'rfpge_author', $post['author']);
    add_post_meta($post_id, 'rfpge_author_link', $post['author_link']);
    add_post_meta($post_id, 'rfpge_author_email', $post['author_email']);
    if($post['auto_delete'] != '' && is_numeric($post['auto_delete']))
    {
        add_post_meta($post_id, 'rfpge_delete_time', intval($post['auto_delete']));
    }
    if($title_url == '1')
    {
        add_post_meta($post_id, 'rfpge_change_title_link', '1');
    }
}

function rfpge_generate_featured_image($image_url, $post_id)
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    $upload_dir = wp_upload_dir();
    if (isset($echo_Main_Settings['no_local_image']) && $echo_Main_Settings['no_local_image'] == 'on') {
        if(!rfpge_url_is_image($image_url))
        {
            return false;
        }
        $file = $upload_dir['basedir'] . '/default_img_rss_echo.jpg';
        if(!file_exists($file))
        {
            $image_data = rfpge_get_web_page(html_entity_decode(dirname(__FILE__) . "/images/icon.png"));
            if ($image_data === FALSE || strpos($image_data, '<Message>Access Denied</Message>') !== FALSE || strpos($image_data, 'ERROR: The requested URL could not be retrieved') !== FALSE) {
                return false;
            }
            
            $ret = file_put_contents($file, $image_data);
            if ($ret === FALSE) {
                return false;
            }
        }
        $filename = basename(dirname(__FILE__) . "/images/icon.png");
        $wp_filetype = wp_check_filetype($filename, null);
        if($wp_filetype['type'] == '')
        {
            $wp_filetype['type'] = 'image/png';
        }
        $attachment  = array(
            'post_mime_type' => $wp_filetype['type'],
            'post_title' => sanitize_file_name($filename),
            'post_content' => '',
            'post_status' => 'inherit'
        );
        
        $attach_id   = wp_insert_attachment($attachment, $file, $post_id);
        if ($attach_id === 0) {
            return false;
        }
        require_once(ABSPATH . 'wp-admin/includes/image.php');
        require_once(ABSPATH . 'wp-admin/includes/media.php');
        $attach_data = wp_generate_attachment_metadata($attach_id, $file);
        wp_update_attachment_metadata($attach_id, $attach_data);
        $res2 = set_post_thumbnail($post_id, $attach_id);
        if ($res2 === FALSE) {
            return false;
        }
        
        return true;
    }
    if(substr( $image_url, 0, 10 ) === "data:image")
    {
        $data = explode(',', $image_url);
        if(isset($data[1]))
        {
            $image_data = base64_decode($data[1]);
            if($image_data === FALSE)
            {
                return false;
            }
        }
        else
        {
            return false;
        }
        preg_match('{data:image/(.*?);}', $image_url ,$ex_matches);
        if(isset($ex_matches[1]))
        {
            $image_url = 'image.' . $ex_matches[1];
        }
        else
        {
            $image_url = 'image.jpg';
        }
    }
    else
    {
        $image_data = rfpge_get_web_page(html_entity_decode($image_url));
        if ($image_data === FALSE || strpos($image_data, '<Message>Access Denied</Message>') !== FALSE) {
            return false;
        }
    }
    $filename = basename($image_url);
    $filename = explode("?", $filename);
    $filename = $filename[0];
    $filename = urlencode($filename);
    $filename = str_replace('%', '-', $filename);
    $filename = str_replace('#', '-', $filename);
    $filename = str_replace('&', '-', $filename);
    $filename = str_replace('{', '-', $filename);
    $filename = str_replace('}', '-', $filename);
    $filename = str_replace('\\', '-', $filename);
    $filename = str_replace('<', '-', $filename);
    $filename = str_replace('>', '-', $filename);
    $filename = str_replace('*', '-', $filename);
    $filename = str_replace('/', '-', $filename);
    $filename = str_replace('$', '-', $filename);
    $filename = str_replace('\'', '-', $filename);
    $filename = str_replace('"', '-', $filename);
    $filename = str_replace(':', '-', $filename);
    $filename = str_replace('@', '-', $filename);
    $filename = str_replace('+', '-', $filename);
    $filename = str_replace('|', '-', $filename);
    $filename = str_replace('=', '-', $filename);
    $filename = str_replace('`', '-', $filename);
    $file_parts = pathinfo($filename);
    
    $post_title = get_the_title($post_id);
    if($post_title != '')
    {
        if(isset($file_parts['extension']))
        {
            switch($file_parts['extension'])
            {
                case "":
                $filename = sanitize_title($post_title) . '.jpg';
                break;
                case NULL:
                $filename = sanitize_title($post_title) . '.jpg';
                break;
                default:
                $filename = sanitize_title($post_title) . '.' . $file_parts['extension'];
                break;
            }
        }
        else
        {
            $filename = sanitize_title($post_title) . '.jpg';
        }
    }
    else
    {
        if(isset($file_parts['extension']))
        {
            switch($file_parts['extension'])
            {
                case "":
                $filename .= '.jpg';
                break;
                case NULL:
                $filename .= '.jpg';
                break;
                default:
                $filename .= '.' . $file_parts['extension'];
                break;
            }
        }
        else
        {
            $filename .= '.jpg';
        }
    }
    $filename = stripslashes(preg_replace_callback('#(%[a-zA-Z0-9_]*)#', function($matches){ return rand(0, 9); }, preg_quote($filename)));if (wp_mkdir_p($upload_dir['path'] . '/' . $post_id))
        $file = $upload_dir['path'] . '/' . $post_id . '/' . $filename;
    else
        $file = $upload_dir['basedir'] . '/' . $post_id . '/' . $filename;
    $ret = file_put_contents($file, $image_data);
    if ($ret === FALSE) {
        return false;
    }
    if ((isset($echo_Main_Settings['resize_height']) && $echo_Main_Settings['resize_height'] !== '') || (isset($echo_Main_Settings['resize_width']) && $echo_Main_Settings['resize_width'] !== ''))
    {
        try
        {
            if(!class_exists('ImageResize'))
            {
                require_once (dirname(__FILE__) . "/res/ImageResize/ImageResize.php");
            }
            $imageRes = new ImageResize($file);
            $imageRes->quality_jpg = 100;
            if ((isset($echo_Main_Settings['resize_height']) && $echo_Main_Settings['resize_height'] !== '') && (isset($echo_Main_Settings['resize_width']) && $echo_Main_Settings['resize_width'] !== ''))
            {
                $imageRes->resizeToBestFit($echo_Main_Settings['resize_width'], $echo_Main_Settings['resize_height'], true);
            }
            elseif (isset($echo_Main_Settings['resize_width']) && $echo_Main_Settings['resize_width'] !== '')
            {
                $imageRes->resizeToWidth($echo_Main_Settings['resize_width'], true);
            }
            elseif (isset($echo_Main_Settings['resize_height']) && $echo_Main_Settings['resize_height'] !== '')
            {
                $imageRes->resizeToHeight($echo_Main_Settings['resize_height'], true);
            }
            $imageRes->save($file);
        }
        catch(Exception $e)
        {
            rfpge_log_to_file('Failed to resize featured image: ' . $image_url . ' to sizes ' . $echo_Main_Settings['resize_width'] . ' - ' . $echo_Main_Settings['resize_height'] . '. Exception thrown ' . $e->getMessage() . '!');
        }
    }
    $wp_filetype = wp_check_filetype($filename, null);
    if($wp_filetype['type'] == '')
    {
        $wp_filetype['type'] = 'image/png';
    }
    $attachment  = array(
        'post_mime_type' => $wp_filetype['type'],
        'post_title' => $post_title,
        'post_content' => '',
        'post_status' => 'inherit'
    );
    $attach_id   = wp_insert_attachment($attachment, $file, $post_id);
    if ($attach_id === 0) {
        return false;
    }
    require_once(ABSPATH . 'wp-admin/includes/image.php');
    require_once(ABSPATH . 'wp-admin/includes/media.php');
    $attach_data = wp_generate_attachment_metadata($attach_id, $file);
    wp_update_attachment_metadata($attach_id, $attach_data);
    $res2 = set_post_thumbnail($post_id, $attach_id);
    if ($res2 === FALSE) {
        return false;
    }
    update_post_meta($attach_id, '_wp_attachment_image_alt', $post_title);
    return true;
}

function rfpge_copy_image_locally($image_url)
{
    $upload_dir = wp_upload_dir();
    
    if(substr( $image_url, 0, 10 ) === "data:image")
    {
        $data = explode(',', $image_url);
        if(isset($data[1]))
        {
            $image_data = base64_decode($data[1]);
            if($image_data === FALSE)
            {
                return false;
            }
        }
        else
        {
            return false;
        }
        preg_match('{data:image/(.*?);}', $image_url ,$ex_matches);
        if(isset($ex_matches[1]))
        {
            $image_url = 'image.' . $ex_matches[1];
        }
        else
        {
            $image_url = 'image.jpg';
        }
    }
    else
    {
        $image_data = rfpge_get_web_page(html_entity_decode($image_url));
        if ($image_data === FALSE || strpos($image_data, '<Message>Access Denied</Message>') !== FALSE) {
            return false;
        }
    }
    $filename = basename($image_url);
    $filename = explode("?", $filename);
    $filename = $filename[0];
    $filename = urlencode($filename);
    $filename = str_replace('%', '-', $filename);
    $filename = str_replace('#', '-', $filename);
    $filename = str_replace('&', '-', $filename);
    $filename = str_replace('{', '-', $filename);
    $filename = str_replace('}', '-', $filename);
    $filename = str_replace('\\', '-', $filename);
    $filename = str_replace('<', '-', $filename);
    $filename = str_replace('>', '-', $filename);
    $filename = str_replace('*', '-', $filename);
    $filename = str_replace('/', '-', $filename);
    $filename = str_replace('$', '-', $filename);
    $filename = str_replace('\'', '-', $filename);
    $filename = str_replace('"', '-', $filename);
    $filename = str_replace(':', '-', $filename);
    $filename = str_replace('@', '-', $filename);
    $filename = str_replace('+', '-', $filename);
    $filename = str_replace('|', '-', $filename);
    $filename = str_replace('=', '-', $filename);
    $filename = str_replace('`', '-', $filename);
    $file_parts = pathinfo($filename);
    switch($file_parts['extension'])
    {
        case "":
        $filename .= 'jpg';
        break;
        case NULL:
        $filename .= '.jpg';
        break;
    }
    if (wp_mkdir_p($upload_dir['path'] . '/echo'))
    {
        $file = $upload_dir['path'] . '/echo/' . $filename;
        $ret_path = $upload_dir['url'] . '/echo/' . $filename;
    }
    else
    {
        $file = $upload_dir['basedir'] . '/' . $filename;
        $ret_path = $upload_dir['baseurl'] . '/' . $filename;
    }
    $ret = file_put_contents($file, $image_data);
    if ($ret === FALSE) {
        return false;
    }
    return $ret_path;
}

function rfpge_url_is_image( $url ) {
    if ( ! filter_var( $url, FILTER_VALIDATE_URL ) ) {
        return FALSE;
    }
    $ext = array( 'jpeg', 'jpg', 'gif', 'png' );
    $info = (array) pathinfo( parse_url( $url, PHP_URL_PATH ) );
    return isset( $info['extension'] )
        && in_array( strtolower( $info['extension'] ), $ext, TRUE );
}

add_filter( 'post_thumbnail_html', 'rfpge_thumbnail_external_replace', 10, 6 );
function rfpge_thumbnail_external_replace( $html, $post_id ) {
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if (isset($echo_Main_Settings['rfpge_enabled']) && $echo_Main_Settings['rfpge_enabled'] === 'on') {
        if (isset($echo_Main_Settings['no_local_image']) && $echo_Main_Settings['no_local_image'] == 'on') {
            wp_suspend_cache_addition(true);
            $url =  get_post_meta( $post_id, 'rfpge_featured_image', TRUE );
            wp_suspend_cache_addition(false);
            if ( empty( $url ) || ! rfpge_url_is_image( $url ) ) {
                return $html;
            }
            $alt = get_post_field( 'post_title', $post_id ) . ' ' .  __( 'thumbnail', 'txtdomain' );
            $attr = array( 'alt' => $alt );
            $attr = apply_filters( 'wp_get_attachment_image_attributes', $attr, NULL );
            $attr = array_map( 'esc_attr', $attr );
            $html = sprintf( '<img src="%s"', esc_url($url) );
            foreach ( $attr as $name => $value ) {
                $html .= " $name=" . '"' . $value . '"';
            }
            $html .= ' />';
        }
    }
    return $html;
}

function rfpge_hour_diff($date1, $date2)
{
    $date1 = new DateTime($date1, rfpge_get_blog_timezone());
    $date2 = new DateTime($date2, rfpge_get_blog_timezone());
    
    $number1 = (int) $date1->format('U');
    $number2 = (int) $date2->format('U');
    return ($number1 - $number2) / 60 / 60;
}

function rfpge_add_hour($date, $hour)
{
    $date1 = new DateTime($date, rfpge_get_blog_timezone());
    $date1->modify("$hour hours");
    foreach ($date1 as $key => $value) {
        if ($key == 'date') {
            return $value;
        }
    }
    return $date;
}

function rfpge_minute_diff($date1, $date2)
{
    $date1 = new DateTime($date1, rfpge_get_blog_timezone());
    $date2 = new DateTime($date2, rfpge_get_blog_timezone());
    
    $number1 = (int) $date1->format('U');
    $number2 = (int) $date2->format('U');
    return ($number1 - $number2) / 60;
}

function rfpge_add_minute($date, $minute)
{
    $date1 = new DateTime($date, rfpge_get_blog_timezone());
    $date1->modify("$minute minutes");
    foreach ($date1 as $key => $value) {
        if ($key == 'date') {
            return $value;
        }
    }
    return $date;
}

function rfpge_wp_custom_css_files($src, $cont)
{
    wp_enqueue_style('rfpge_thumbnail_css_' . $cont, $src, __FILE__);
}
function rfpge_get_blog_timezone() {

    $tzstring = get_option( 'timezone_string' );
    $offset   = get_option( 'gmt_offset' );

    if( empty( $tzstring ) && 0 != $offset && floor( $offset ) == $offset ){
        $offset_st = $offset > 0 ? "-$offset" : '+'.absint( $offset );
        $tzstring  = 'Etc/GMT'.$offset_st;
    }
    if( empty( $tzstring ) ){
        $tzstring = 'UTC';
    }
    $timezone = new DateTimeZone( $tzstring );
    return $timezone; 
}
function rfpge_get_date_now($param = 'now')
{
    $date = new DateTime($param, rfpge_get_blog_timezone());
    foreach ($date as $key => $value) {
        if ($key == 'date') {
            return $value;
        }
    }
    return '';
}

function rfpge_create_terms($taxonomy, $parent, $terms_str, $remove_cats)
{
    if($remove_cats != '')
    {
        $remove_cats = explode(',', $remove_cats);
    }
    else
    {
        $remove_cats = array();
    }
    $terms          = explode(',', $terms_str);
    $categories     = array();
    $parent_term_id = $parent;
    foreach ($terms as $term) {
        $term = trim($term);
        $skip = false;
        foreach($remove_cats as $skip)
        {
            if(strcasecmp(trim($skip), $term) == 0)
            {
                $skip = true;
                break;
            }
        }
        if($skip === true)
        {
            continue;
        }
        $res = term_exists($term, $taxonomy);
        if ($res != NULL && $res != 0 && count($res) > 0 && isset($res['term_id'])) {
            $parent_term_id = $res['term_id'];
            $categories[]   = $parent_term_id;
        } else {
            $new_term = wp_insert_term($term, $taxonomy, array(
                'parent' => $parent
            ));
            if (!is_wp_error( $new_term ) && $new_term != NULL && $new_term != 0 && count($new_term) > 0 && isset($new_term['term_id'])) {
                $parent_term_id = $new_term['term_id'];
                $categories[]   = $parent_term_id;
            }
        }
    }
    
    return $categories;
}
function rfpge_getExcerpt($the_content, $words = 55)
{
    if($words == '')
    {
        $words = 55;
    }
    $preview = rfpge_strip_html_tags($the_content);
    $preview = wp_trim_words($preview, $words);
    return $preview;
}

function rfpge_getPlainContent($the_content)
{
    $preview = rfpge_strip_html_tags($the_content);
    $preview = wp_trim_words($preview, 999999);
    return $preview;
}
function rfpge_getItemImage($img)
{
    $preview = '<img src="' . $img . '" alt="image" />';
    return $preview;
}

function rfpge_getReadMoreButton($url, $read_more)
{
    $link = '';
    if (isset($url)) {
        $echo_Main_Settings = get_option('echo_Main_Settings', false);
        if($read_more == '')
        {
            if (isset($echo_Main_Settings['read_more_text']) && $echo_Main_Settings['read_more_text'] != '') {
                $read_more = $echo_Main_Settings['read_more_text'];
            }
            else
            {
                $read_more = 'Read More';
            }
        }
        $link = '<a style="white-space: nowrap" href="' . $url . '" class="button purchase" target="_blank">' . $read_more . '</a>';
    }
    return $link;
}

add_action('admin_head', 'rfpge_my_custom_fonts');

function rfpge_my_custom_fonts()
{
    echo '<style>#taxonomy-rfpge_post{width:100px;}}</style>';
}

add_action('init', 'rfpge_create_taxonomy', 0);

function rfpge_create_taxonomy()
{
    if(isset($_GET['run_echo']) && $_GET['run_echo'] !== '')
    {
        $echo_Main_Settings = get_option('echo_Main_Settings', false);
        if(isset($echo_Main_Settings['secret_word']) && $_GET['run_echo'] == $echo_Main_Settings['secret_word'])
        {
            rfpge_cron();
            die();
        }
    }
    $tz = rfpge_get_blog_timezone();
    if($tz !== false)
        date_default_timezone_set($tz->getName());
    add_image_size( 'rfpge_preview_image', 260, 146);
    if(!taxonomy_exists('coderevolution_post_source'))
    {
        $labels = array(
            'name' => _x('Post Source', 'taxonomy general name', 'textdomain'),
            'singular_name' => _x('Post Source', 'taxonomy singular name', 'textdomain'),
            'search_items' => __('Search Post Source', 'textdomain'),
            'popular_items' => __('Popular Post Source', 'textdomain'),
            'all_items' => __('All Post Sources', 'textdomain'),
            'parent_item' => null,
            'parent_item_colon' => null,
            'edit_item' => __('Edit Post Source', 'textdomain'),
            'update_item' => __('Update Post Source', 'textdomain'),
            'add_new_item' => __('Add New Post Source', 'textdomain'),
            'new_item_name' => __('New Post Source Name', 'textdomain'),
            'separate_items_with_commas' => __('Separate Post Source with commas', 'textdomain'),
            'add_or_remove_items' => __('Add or remove Post Source', 'textdomain'),
            'choose_from_most_used' => __('Choose from the most used Post Source', 'textdomain'),
            'not_found' => __('No Post Sources found.', 'textdomain'),
            'menu_name' => __('Post Source', 'textdomain')
        );
        
        $args = array(
            'hierarchical' => false,
            'description' => 'Post Source',
            'labels' => $labels,
            'show_ui' => true,
            'show_admin_column' => true,
            'update_count_callback' => '_update_post_term_count',
            'query_var' => true,
            'rewrite' => array(
                'slug' => 'coderevolution_post_source'
            )
        );
        
        register_taxonomy('coderevolution_post_source', array(
            'post',
            'page'
        ), $args);
    }
}

register_activation_hook(__FILE__, 'rfpge_activation_callback');
function rfpge_activation_callback($defaults = FALSE)
{
    rfpge_create_system_cron();
    if (!get_option('rfpge_posts_per_page') || $defaults === TRUE) {
        if ($defaults === FALSE) {
            add_option('rfpge_posts_per_page', '16');
        } else {
            update_option('rfpge_posts_per_page', '16');
        }
    }
    if (!get_option('echo_Main_Settings') || $defaults === TRUE) {
        $echo_Main_Settings = array(
            'rfpge_enabled' => 'on',
            'disable_excerpt' => '',
            'excerpt_length' => '55',
            'enable_metabox' => 'on',
            'skip_no_img' => '',
            'require_only_one' => '',
            'skip_old' => '',
            'skip_year' => '',
            'skip_month' => '',
            'skip_day' => '',
            'custom_html2' => '',
            'custom_html' => '',
            'rfpge_get_image_from_content' => 'on',
            'sentence_list' => 'This is one %adjective %noun %sentence_ending
This is another %adjective %noun %sentence_ending
I %love_it %nouns , because they are %adjective %sentence_ending
My %family says this plugin is %adjective %sentence_ending
These %nouns are %adjective %sentence_ending',
            'sentence_list2' => 'Meet this %adjective %noun %sentence_ending
This is the %adjective %noun ever%sentence_ending
I %love_it %nouns , because they are the %adjective %sentence_ending
My %family says this plugin is very %adjective %sentence_ending
These %nouns are quite %adjective %sentence_ending',
            'variable_list' => 'adjective_very => %adjective;very %adjective;

adjective => clever;interesting;smart;huge;astonishing;unbelievable;nice;adorable;beautiful;elegant;fancy;glamorous;magnificent;helpful;awesome

noun_with_adjective => %noun;%adjective %noun

noun => plugin;WordPress plugin;item;ingredient;component;constituent;module;add-on;plug-in;addon;extension

nouns => plugins;WordPress plugins;items;ingredients;components;constituents;modules;add-ons;plug-ins;addons;extensions

love_it => love;adore;like;be mad for;be wild about;be nuts about;be crazy about

family => %adjective %family_members;%family_members

family_members => grandpa;brother;sister;mom;dad;grandma

sentence_ending => .;!;!!',
            'auto_clear_logs' => 'No',
            'enable_logging' => 'on',
            'enable_detailed_logging' => '',
            'rule_timeout' => '3600',
            'strip_links' => '',
            'strip_featured_image' => '',
            'strip_scripts' => '',
            'email_address' => '',
            'send_email' => '',
            'send_post_email' => '',
            'best_password' => '',
            'protected_terms' => '',
            'best_user' => '',
            'spin_text' => 'disabled',
            'max_word_content' => '',
            'min_word_content' => '',
            'max_word_title' => '',
            'min_word_title' => '',
            'rfpge_custom_simplepie' => '',
            'rfpge_force_feeds' => '',
            'rfpge_enable_caching' => '',
            'rfpge_featured_image_checking' => '',
            'rfpge_clear_curl_charset' => '',
            'search_google' => '',
            'resize_width' => '',
            'resize_height' => '',
            'read_more_text' => 'Read More',
            'no_local_image' => '',
            'clear_user_agent' => '',
            'auto_delete_enabled' => '',
            'no_title_spin' => '',
            'copy_images' => '',
            'rule_delay' => '',
            'no_spin' => '',
            'replace_url' => '',
            'link_attributes_external' => '',
            'link_append' => '',
            'link_attributes_internal' => '',
            'do_not_check_duplicates' => '',
            'append_enclosure' => '',
            'link_source' => '',
            'iframe_resize_height' => '',
            'iframe_resize_width' => '',
            'skip_image_names' => '',
            'replace_cron' => '',
            'no_check' => '',
            'draft_first' => '',
            'global_req_words' => '',
            'global_ban_words' => '',
            'new_category' => '',
            'proxy_auth' => '',
            'secret_word' => '',
            'proxy_url' => ''
        );
        if ($defaults === FALSE) {
            add_option('echo_Main_Settings', $echo_Main_Settings);
        } else {
            update_option('echo_Main_Settings', $echo_Main_Settings);
        }
    }
}


function rfpge_spin_text($title, $content, $alt = false)
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    $titleSeparator = '[19459000]';
    $text           = $title . $titleSeparator . $content;
    $text           = html_entity_decode($text);
    preg_match_all("/<[^<>]+>/is", $text, $matches, PREG_PATTERN_ORDER);
    $htmlfounds         = array_filter(array_unique($matches[0]));
    $htmlfounds[]       = '&quot;';
    $imgFoundsSeparated = array();
    foreach ($htmlfounds as $key => $currentFound) {
        if (stristr($currentFound, '<img') && stristr($currentFound, 'alt')) {
            $altSeparator   = '';
            $colonSeparator = '';
            if (stristr($currentFound, 'alt="')) {
                $altSeparator   = 'alt="';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt = "')) {
                $altSeparator   = 'alt = "';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt ="')) {
                $altSeparator   = 'alt ="';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt= "')) {
                $altSeparator   = 'alt= "';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt=\'')) {
                $altSeparator   = 'alt=\'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt = \'')) {
                $altSeparator   = 'alt = \'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt= \'')) {
                $altSeparator   = 'alt= \'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt =\'')) {
                $altSeparator   = 'alt =\'';
                $colonSeparator = '\'';
            }
            if (trim($altSeparator) != '') {
                $currentFoundParts = explode($altSeparator, $currentFound);
                $preAlt            = $currentFoundParts[1];
                $preAltParts       = explode($colonSeparator, $preAlt);
                $altText           = $preAltParts[0];
                if (trim($altText) != '') {
                    unset($preAltParts[0]);
                    $imgFoundsSeparated[] = $currentFoundParts[0] . $altSeparator;
                    $imgFoundsSeparated[] = $colonSeparator . implode('', $preAltParts);
                    $htmlfounds[$key]     = '';
                }
            }
        }
    }
    if (count($imgFoundsSeparated) != 0) {
        $htmlfounds = array_merge($htmlfounds, $imgFoundsSeparated);
    }
    preg_match_all("/<\!--.*?-->/is", $text, $matches2, PREG_PATTERN_ORDER);
    $newhtmlfounds = $matches2[0];
    preg_match_all("/\[.*?\]/is", $text, $matches3, PREG_PATTERN_ORDER);
    $shortcodesfounds = $matches3[0];
    $htmlfounds       = array_merge($htmlfounds, $newhtmlfounds, $shortcodesfounds);
    $in               = 0;
    $cleanHtmlFounds  = array();
    foreach ($htmlfounds as $htmlfound) {
        if ($htmlfound == '[19459000]') {
        } elseif (trim($htmlfound) == '') {
        } else {
            $cleanHtmlFounds[] = $htmlfound;
        }
    }
    $htmlfounds = $cleanHtmlFounds;
    $start      = 19459001;
    foreach ($htmlfounds as $htmlfound) {
        $text = str_replace($htmlfound, '[' . $start . ']', $text);
        $start++;
    }
    try {
        if(!class_exists('PhpTextSpinner'))
        {
            require_once(dirname(__FILE__) . "/res/echo-text-spinner.php");
        }
        $phpTextSpinner = new PhpTextSpinner();
        if ($alt === FALSE) {
            $spinContent = $phpTextSpinner->spinContent($text);
        } else {
            $spinContent = $phpTextSpinner->spinContentAlt($text);
        }
        $translated = $phpTextSpinner->runTextSpinner($spinContent);
    }
    catch (Exception $e) {
        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
            rfpge_log_to_file('Exception thrown in spinText ' . $e);
        }
        return false;
    }
    preg_match_all('{\[.*?\]}', $translated, $brackets);
    $brackets = $brackets[0];
    $brackets = array_unique($brackets);
    foreach ($brackets as $bracket) {
        if (stristr($bracket, '19')) {
            $corrrect_bracket = str_replace(' ', '', $bracket);
            $corrrect_bracket = str_replace('.', '', $corrrect_bracket);
            $corrrect_bracket = str_replace(',', '', $corrrect_bracket);
            $translated       = str_replace($bracket, $corrrect_bracket, $translated);
        }
    }
    if (stristr($translated, $titleSeparator)) {
        $start = 19459001;
        foreach ($htmlfounds as $htmlfound) {
            $translated = str_replace('[' . $start . ']', $htmlfound, $translated);
            $start++;
        }
        $contents = explode($titleSeparator, $translated);
        $title    = $contents[0];
        $content  = $contents[1];
    } else {
        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
            rfpge_log_to_file('Failed to parse spinned content, separator not found');
        }
        return false;
    }
    return array(
        $title,
        $content
    );
}

class Echo_Spintax
{
    public function process($text)
    {
        return stripslashes(preg_replace_callback(
            '/\{(((?>[^\{\}]+)|(?R))*)\}/x',
            array($this, 'replace'),
            preg_quote($text)
        ));
    }
    public function replace($text)
    {
        $text = $this->process($text[1]);
        $parts = explode('|', $text);
        return $parts[array_rand($parts)];
    }
}
function rfpge_best_spin_text($title, $content)
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if (!isset($echo_Main_Settings['best_user']) || $echo_Main_Settings['best_user'] == '' || !isset($echo_Main_Settings['best_password']) || $echo_Main_Settings['best_password'] == '') {
        rfpge_log_to_file('Please insert a valid "The Best Spinner" user name and password.');
        return FALSE;
    }
    $titleSeparator   = '[19459000]';
    $newhtml             = $title . $titleSeparator . $content;
    $url              = 'http://thebestspinner.com/api.php';
    $data             = array();
    $data['action']   = 'authenticate';
    $data['format']   = 'php';
    $data['username'] = $echo_Main_Settings['best_user'];
    $data['password'] = $echo_Main_Settings['best_password'];
    $fdata = "";
    foreach ($data as $key => $val) {
        $fdata .= "$key=" . urlencode($val) . "&";
    }
    $html = wp_remote_post(
        $url,
        array(
        'sslverify' => false,
        'timeout' => 10,
        'body' => $fdata
        )
    );

    if (is_wp_error($html)) {
        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
            rfpge_log_to_file('"The Best Spinner" failed to exec curl.');
        }
        return FALSE;
    }
    $output = unserialize($html['body']);
    if ($output['success'] == 'true') {
        $session                = $output['session'];
        $data                   = array();
        $data['session']        = $session;
        $data['format']         = 'php';
        if (isset($echo_Main_Settings['protected_terms']) && $echo_Main_Settings['protected_terms'] != '') 
        {
            $protected_terms = $echo_Main_Settings['protected_terms'];
        }
        else
        {
            $protected_terms = '';
        }
        
        $data['protectedterms'] = $protected_terms;
        $data['text']           = html_entity_decode($newhtml);
        $data['action']         = 'replaceEveryonesFavorites';
        $data['maxsyns']        = '50';
        $data['quality']        = '1';
        $fdata = "";
        foreach ($data as $key => $val) {
            $fdata .= "$key=" . urlencode($val) . "&";
        }
        $output = wp_remote_post(
            $url,
            array(
            'sslverify' => false,
            'timeout' => 10,
            'body' => $fdata
            )
        );
        if (is_wp_error($output)) {
            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                rfpge_log_to_file('"The Best Spinner" failed to exec curl after auth.');
            }
            return FALSE;
        }
        $output = unserialize($output['body']);
        if ($output['success'] == 'true') {
            $result = explode($titleSeparator, $output['output']);
            if (count($result) < 2) {
                if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                    rfpge_log_to_file('"The Best Spinner" failed to spin article - titleseparator not found. ' . print_r($output, true));
                }
                return FALSE;
            }
            $spintax = new Echo_Spintax();
            $result[0] = $spintax->process($result[0]);
            $result[1] = $spintax->process($result[1]);
            return $result;
        } else {
            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                rfpge_log_to_file('"The Best Spinner" failed to spin article. ' . print_r($output, true));
            }
            return FALSE;
        }
    } else {
        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
            rfpge_log_to_file('"The Best Spinner" authentification failed. ' . print_r($output, true));
        }
        return FALSE;
    }
}

function rfpge_wordai_spin_text($title, $content)
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if (!isset($echo_Main_Settings['best_user']) || $echo_Main_Settings['best_user'] == '' || !isset($echo_Main_Settings['best_password']) || $echo_Main_Settings['best_password'] == '') {
        rfpge_log_to_file('Please insert a valid "Wordai" user name and password.');
        return FALSE;
    }
    $titleSeparator   = '[19459000]';
    $quality = '50';
    $html             = $title . $titleSeparator . $content;
    $email = $echo_Main_Settings['best_user'];
    $pass = $echo_Main_Settings['best_password'];
    $html = urlencode($html);
    $result = wp_remote_post(
        'http://wordai.com/users/regular-api.php',
        array(
            'sslverify' => false,
            'timeout' => 10,
            'body' => "s=$html&quality=$quality&email=$email&pass=$pass&output=json"
        )
    );
    if (is_wp_error($result)) {
        rfpge_log_to_file('"Wordai" failed to exec curl after auth.');
        return FALSE;
    }
    $result = json_decode($result['body']);
    if(!isset($result->text))
    {
        rfpge_log_to_file('"Wordai" unrecognized response: ' . print_r($result, true));
        return FALSE;
    }
    $spintax = new Echo_Spintax();
    $result = $spintax->process($result);
    return $result;
}

function rfpge_spin_and_translate($post_title, $final_content, $translate, $source_lang)
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if (isset($echo_Main_Settings['spin_text']) && $echo_Main_Settings['spin_text'] !== 'disabled') {
        if ($echo_Main_Settings['spin_text'] == 'builtin') {
            $translation = rfpge_builtin_spin_text($post_title, $final_content);
        } elseif ($echo_Main_Settings['spin_text'] == 'wikisynonyms') {
            $translation = rfpge_spin_text($post_title, $final_content, false);
        } elseif ($echo_Main_Settings['spin_text'] == 'freethesaurus') {
            $translation = rfpge_spin_text($post_title, $final_content, true);
        } elseif ($echo_Main_Settings['spin_text'] == 'best') {
            $translation = rfpge_best_spin_text($post_title, $final_content);
        } elseif ($echo_Main_Settings['spin_text'] == 'wordai') {
            $translation = rfpge_wordai_spin_text($post_title, $final_content);
        }
        if ($translation !== FALSE) {
            if (is_array($translation) && isset($translation[0]) && isset($translation[1])) {
                if (isset($echo_Main_Settings['no_title_spin']) && $echo_Main_Settings['no_title_spin'] == 'on') {
                }
                else
                {
                    $post_title    = $translation[0];
                }
                $final_content = $translation[1];
            } else {
                if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                    rfpge_log_to_file('Text Spinning failed - malformed data ' . $echo_Main_Settings['spin_text']);
                }
            }
        } else {
            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                rfpge_log_to_file('Text Spinning Failed - returned false ' . $echo_Main_Settings['spin_text']);
            }
        }
    }
    if ($translate != 'disabled') {
        $translation = rfpge_translate($post_title, $final_content, $source_lang, $translate);
        if ($translation !== FALSE) {
            if (is_array($translation) && isset($translation[0]) && isset($translation[1])) {
                $post_title    = $translation[0];
                $final_content = $translation[1];
                $final_content = str_replace('</ iframe>', '</iframe>', $final_content);
                if(stristr($final_content, '<head>') !== false)
                {
                    $d = new DOMDocument;
                    $mock = new DOMDocument;
                    @$d->loadHTML('<?xml encoding="utf-8" ?>' . $final_content);
                    $body = $d->getElementsByTagName('body')->item(0);
                    foreach ($body->childNodes as $child)
                    {
                        $mock->appendChild($mock->importNode($child, true));
                    }
                    $new_post_content_temp = $mock->saveHTML();
                    if($new_post_content_temp !== '' && $new_post_content_temp !== false)
                    {
                        $final_content = preg_replace("/_addload\(function\(\){([^<]*)/i", "", $new_post_content_temp); 
                    }
                }
                $final_content = htmlspecialchars_decode($final_content);
                $final_content = str_replace('</ ', '</', $final_content);
                $final_content = str_replace(' />', '/>', $final_content);
                $final_content = str_replace('< br/>', '<br/>', $final_content);
                $final_content = str_replace('< / ', '</', $final_content);
                $final_content = str_replace(' / >', '/>', $final_content);
                $final_content = str_replace('</​​h2>', '</h2>', $final_content);
                $final_content = str_replace('</​​h2>', '</h2>', $final_content);
                $final_content = preg_replace('/[\x00-\x1F\x7F\xA0]/u', '', $final_content);
                $post_title = htmlspecialchars_decode($post_title);
                $post_title = str_replace('</ ', '</', $post_title);
                $post_title = str_replace(' />', '/>', $post_title);
                $post_title = preg_replace('/[\x00-\x1F\x7F\xA0]/u', '', $post_title);
            } else {
                if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                    rfpge_log_to_file('Translation failed - malformed data!');
                }
            }
        } else {
            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                rfpge_log_to_file('Translation Failed - returned false!');
            }
        }
    }
    return array(
        $post_title,
        $final_content
    );
}

function rfpge_translate($title, $content, $from, $to)
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    $ch = FALSE;
    try {
        if($from == 'disabled')
        {
            $from = 'en';
        }
        if(!class_exists('GoogleTranslator'))
        {
            require_once(dirname(__FILE__) . "/res/echo-translator.php");
        }
        $ch = curl_init();
        if ($ch === FALSE) {
            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                rfpge_log_to_file('Failed to init cURL in translator!');
            }
            return false;
        }
        if (isset($echo_Main_Settings['proxy_url']) && $echo_Main_Settings['proxy_url'] != '') {
            curl_setopt($ch, CURLOPT_PROXY, $echo_Main_Settings['proxy_url']);
            if (isset($echo_Main_Settings['proxy_auth']) && $echo_Main_Settings['proxy_auth'] != '') {
                curl_setopt($ch, CURLOPT_PROXYUSERPWD, $echo_Main_Settings['proxy_auth']);
            }
        }
        //GoogleTranslator is an external library and it requires curl
        $GoogleTranslator = new GoogleTranslator($ch);
        if(strlen($content) > 30000)
        {
            $translated = '';
            while($content != '')
            {
                $first30k = substr($content, 0, 30000);
                $content = substr($content, 30000);
                $translated_temp       = $GoogleTranslator->translateText($first30k, $from, $to);
                if (strpos($translated, '<h2>The page you have attempted to translate is already in ') !== false) {
                    throw new Exception('Page content already in ' . $to);
                }
                $translated_temp = trim(trim($translated_temp, '</pre>'), '<pre>');
                $translated .= ' ' . $translated_temp;
            }
        }
        else
        {
            $translated       = $GoogleTranslator->translateText($content, $from, $to);
            if (strpos($translated, '<h2>The page you have attempted to translate is already in ') !== false) {
                throw new Exception('Page content already in ' . $to);
            }
        }
        $translated_title = $GoogleTranslator->translateText($title, $from, $to);
        curl_close($ch);
    }
    catch (Exception $e) {
        curl_close($ch);
        if (isset($echo_Main_Settings['enable_detailed_logging'])) {
            rfpge_log_to_file('Exception thrown in GoogleTranslator ' . $e);
        }
        return false;
    }
    $title = trim(trim($translated_title, '</pre>'), '<pre>');
    $text  = trim(trim($translated, '</pre>'), '<pre>');
    $text  = preg_replace('/' . preg_quote('html lang=') . '.*?' . preg_quote('>') . '/', '', $text);
    $text  = preg_replace('/' . preg_quote('!DOCTYPE') . '.*?' . preg_quote('<') . '/', '', $text);
    return array(
        $title,
        $text
    );
}

function rfpge_strip_html_tags($str)
{
    $str = html_entity_decode($str);
    $str = preg_replace('/(<|>)\1{2}/is', '', $str);
    $str = preg_replace(array(
        '@<head[^>]*?>.*?</head>@siu',
        '@<style[^>]*?>.*?</style>@siu',
        '@<script[^>]*?.*?</script>@siu',
        '@<noscript[^>]*?.*?</noscript>@siu'
    ), "", $str);
    $str = strip_tags($str);
    return $str;
}

function rfpge_DOMinnerHTML(DOMNode $element)
{
    $innerHTML = "";
    $children  = $element->childNodes;
    
    foreach ($children as $child) {
        $innerHTML .= @$element->ownerDocument->saveHTML($child);
    }
    
    return $innerHTML;
}

function rfpge_url_exists($url)
{
    $headers = @rfpge_get_url_header($url);
    if (strpos($headers[0], '200') === false)
        return false;
    return true;
}
function rfpge_convert_readable_html($html_string) {

    if(!class_exists('Readability'))
    {
        require_once (dirname(__FILE__) . "/res/echo-readability.php");
    }
	
	$readability = new Readability($html_string);
	$readability->debug = false;
	$readability->convertLinksToFootnotes = false;
	$result = $readability->init();
	if ($result) {
		$content = $readability->getContent()->innerHTML;
		return $content;
	} else {
		return '';
	}
}
function rfpge_get_full_content($url, $type, $getname, $only_text, $single, $inner, $get_css, $encoding)
{
    if(!class_exists('rfpge_html_dom_simple_html_dom_node'))
    {
        require_once (dirname(__FILE__) . "/res/simple_html_dom.php"); 
    }
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    $extract = '';
    $htmlcontent = '';
    if($getname == '')
    {
        $htmlcontent = rfpge_get_web_page($url);
        if($htmlcontent === FALSE)
        {
            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                rfpge_log_to_file('rfpge_get_web_page failed for: ' . $url . ', xpath type: ' . $getname . '!');
            }
            return false;
        }
        $extract = rfpge_convert_readable_html($htmlcontent);
    }
    else
    {
        if ($type == 'regex') {
            $htmlcontent = rfpge_get_web_page($url);
            if($htmlcontent === FALSE)
            {
                return FALSE;
            }
            $matches     = array();
            preg_match_all($getname, $htmlcontent, $matches);
            if ($getname === FALSE) {
                if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                    rfpge_log_to_file('[rfpge_get_full_content] preg_match_all failed for expr: ' . $getname . '!');
                }
                return false;
            }
            if ($inner == '1')
            {
                if(isset($matches[1]))
                {
                    foreach ($matches[1] as $match) {
                        $extract .= $match;
                        if ($single == '1') {
                            break;
                        }
                    }
                }
            }
            else
            {
                if(isset($matches[0]))
                {
                    foreach ($matches[0] as $match) {
                        $extract .= $match;
                        if ($single == '1') {
                            break;
                        }
                    }
                }
            }
        } elseif ($type == 'xpath') {
            $htmlcontent = rfpge_get_web_page($url);
            if($htmlcontent === FALSE)
            {
                if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                    rfpge_log_to_file('rfpge_get_web_page failed for: ' . $url . ', xpath type: ' . $getname . '!');
                }
                return false;
            }
            $html_dom_original_html = html_dom_str_get_html($htmlcontent);
            if(method_exists($html_dom_original_html, 'find')){
                $ret = $html_dom_original_html->find( trim($getname) );
                foreach ($ret as $item ) {
                    if($inner == '1'){
                        $extract = $extract . $item->innertext ;
                    }else{
                        $extract = $extract . $item->outertext ;
                    }
                    if ($single == '1') {
                        break;
                    }		
                }
                $html_dom_original_html->clear();
                unset($html_dom_original_html);
            }
            else
            {
                if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                    rfpge_log_to_file('html_dom_str_get_html failed for: ' . $url . ', xpath: ' . $getname . '!');
                }
                return false;
            }
        } else {
            $htmlcontent = rfpge_get_web_page($url);
            if($htmlcontent === FALSE)
            {
                if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                    rfpge_log_to_file('rfpge_get_web_page failed for: ' . $url . ', class query type: ' . $getname . '!');
                }
                return false;
            }
            $html_dom_original_html = html_dom_str_get_html($htmlcontent);
            if(method_exists($html_dom_original_html, 'find')){
                $getnames = explode(',', $getname);
                foreach($getnames as $gname)
                {
                    $ret = $html_dom_original_html->find('*['.$type.'="'.trim($gname).'"]');
                    foreach ($ret as $item ) {
                        if($inner == '1'){
                            $extract = $extract . $item->innertext ;
                        }else{
                            $extract = $extract . $item->outertext ;
                        }
                        if ($single == '1') {
                            break;
                        }		
                    }
                }
                $html_dom_original_html->clear();
                unset($html_dom_original_html);
            }
            else
            {
                if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                    rfpge_log_to_file('html_dom_str_get_html failed for: ' . $url . ', find does not exist: ' . $getname . '!');
                }
                return false;
            }
        }
        if($extract == '')
        {
            $extract = rfpge_convert_readable_html($htmlcontent);
        }
    }
    if ($encoding != 'UTF-8' && $encoding != 'NO_CHANGE')
    {
        $extract_temp = FALSE;
        if($encoding !== 'AUTO')
        {
            $extract_temp = @iconv($encoding, "UTF-8//IGNORE", $extract);
        }
        else
        {
            if(function_exists('mb_detect_encoding'))
            {
                $temp_enc = mb_detect_encoding($extract, 'auto');
                if ($temp_enc !== FALSE && $temp_enc != 'UTF-8')
                {
                    $extract_temp = @iconv($temp_enc, "UTF-8//IGNORE", $extract);
                }
            }
        }
        if($extract_temp !== FALSE)
        {
            $extract = $extract_temp;
        }
        else
        {
            if (isset($echo_Main_Settings['enable_detailed_logging'])) {
                rfpge_log_to_file('Failed to convert to encoding ' . $encoding);
            }
        }
    }
    $my_url  = parse_url($url);
	$my_host = $my_url['host'];
    preg_match_all('{src[\s]*=[\s]*["|\'](.*?)["|\'].*?>}is', $extract , $matches);
	$img_srcs =  ($matches[1]);
	foreach ($img_srcs as $img_src){
		$original_src = $img_src;
        if(stristr($img_src, '../')){
			$img_src = str_replace('../', '', $img_src);
		}
		if(stristr($img_src, 'http:') === FALSE && stristr($img_src, 'www.') === FALSE && stristr($img_src, 'https:') === FALSE && stristr($img_src, 'data:image') === FALSE)
		{
			$img_src = trim($img_src);
			if(preg_match('{^//}', $img_src)){
				$img_src = 'http:'.$img_src;
			}elseif( preg_match('{^/}', $img_src) ){
				$img_src = 'http://'.$my_host.$img_src;
			}else{
				$img_src = 'http://'.$my_host.'/'.$img_src;
			}
			$reg_img = '{["|\'][\s]*'.preg_quote($original_src,'{').'[\s]*["|\']}s';
            $extract = preg_replace( $reg_img, '"'.$img_src.'"', $extract);
		}
	}
    $extract = str_replace('href="../', 'href="http://'.$my_host.'/', $extract);
	$extract = preg_replace('{href="/(\w)}', 'href="http://'.$my_host.'/$1', $extract);
    $extract = preg_replace('{srcset=".*?"}', '', $extract);
	$extract = preg_replace('{sizes=".*?"}', '', $extract);
    $extract = html_entity_decode($extract) ;
    if (isset($echo_Main_Settings['strip_scripts']) && $echo_Main_Settings['strip_scripts'] == 'on') {
        $extract = preg_replace('{<ins.*?ins>}s', '', $extract);
        $extract = preg_replace('{<ins.*?>}s', '', $extract);
        $extract = preg_replace('{<script.*?script>}s', '', $extract);
        $extract = preg_replace('{\(adsbygoogle.*?\);}s', '', $extract);
    }
    if ($only_text == '1') {
        $striphtml = rfpge_strip_html_tags($extract);
        return $striphtml;
    } else {
        return $extract;
    }
}
function rfpge_substr_close_tags($text, $max_length)
{
    $tags   = array();
    $result = "";

    $is_open   = false;
    $grab_open = false;
    $is_close  = false;
    $in_double_quotes = false;
    $in_single_quotes = false;
    $tag = "";

    $i = 0;
    $stripped = 0;

    $stripped_text = strip_tags($text);

    while ($i < strlen($text) && $stripped < strlen($stripped_text) && $stripped < $max_length)
    {
        $symbol  = $text{$i};
        $result .= $symbol;

        switch ($symbol)
        {
           case '<':
                $is_open   = true;
                $grab_open = true;
                break;

           case '"':
               if ($in_double_quotes)
                   $in_double_quotes = false;
               else
                   $in_double_quotes = true;

            break;

            case "'":
              if ($in_single_quotes)
                  $in_single_quotes = false;
              else
                  $in_single_quotes = true;

            break;

            case '/':
                if ($is_open && !$in_double_quotes && !$in_single_quotes)
                {
                    $is_close  = true;
                    $is_open   = false;
                    $grab_open = false;
                }

                break;

            case ' ':
                if ($is_open)
                    $grab_open = false;
                else
                    $stripped++;

                break;

            case '>':
                if ($is_open)
                {
                    $is_open   = false;
                    $grab_open = false;
                    array_push($tags, $tag);
                    $tag = "";
                }
                else if ($is_close)
                {
                    $is_close = false;
                    array_pop($tags);
                    $tag = "";
                }

                break;

            default:
                if ($grab_open || $is_close)
                    $tag .= $symbol;

                if (!$is_open && !$is_close)
                    $stripped++;
        }

        $i++;
    }

    while ($tags)
        $result .= "</".array_pop($tags).">";

    return $result;
}


register_activation_hook(__FILE__, 'rfpge_check_version');
function rfpge_check_version()
{
    global $wp_version;
    if (!current_user_can('activate_plugins')) {
        echo '<p>' . sprintf(__('You are not allowed to activate plugins!', 'oe-sb'), $php_version_required) . '</p>';
        die;
    }
    $php_version_required = '5.0';
    $wp_version_required  = '2.7';
    
    if (version_compare(PHP_VERSION, $php_version_required, '<')) {
        deactivate_plugins(basename(__FILE__));
        echo '<p>' . sprintf(__('This plugin can not be activated because it requires a PHP version greater than %1$s. Please update your PHP version before you activate it.', 'oe-sb'), $php_version_required) . '</p>';
        die;
    }
    
    if (version_compare($wp_version, $wp_version_required, '<')) {
        deactivate_plugins(basename(__FILE__));
        echo '<p>' . sprintf(__('This plugin can not be activated because it requires a WordPress version greater than %1$s. Please go to Dashboard &#9656; Updates to get the latest version of WordPress .', 'oe-sb'), $wp_version_required) . '</p>';
        die;
    }
}
function rfpge_get_pinfo() {
    ob_start();
    phpinfo();
    $data = ob_get_contents();
    ob_clean();
    return $data;
}

function rfpge_check_exec_works() 
{
	if (function_exists("exec")) {
		@exec('pwd', $output, $return);
		return $return == 0;
	} else {
		return false;
	}
}
function rfpge_create_system_cron() 
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if (isset($echo_Main_Settings['rfpge_enabled']) && $echo_Main_Settings['rfpge_enabled'] == 'on') 
    {
        if (isset($echo_Main_Settings['replace_cron']) && $echo_Main_Settings['replace_cron'] == 'on')
        {
            if (!rfpge_check_exec_works()) 
            {
                return false;
            }
            $command_string = '0 * * * * wget -q --user-agent="rfpge_create_system_cron" -O - ' . site_url() . ' >/dev/null 2>&1';
            exec('crontab -l', $output, $return);
            $output = implode(PHP_EOL, $output);
            if (!$return) 
            {
                if (strpos($output, $command_string) === false) 
                {
                    $command_string = $output . PHP_EOL . $command_string . PHP_EOL;
                    $cron_file = dirname(__FILE__) . "/res/rfpge_cron_file.txt";
                    touch($cron_file);
                    chmod($cron_file, 0755);
                    $rez = file_put_contents($cron_file, $command_string);
                    if($rez === false)
                    {
                        rfpge_log_to_file('Failed to put file contents to cron file');
                        return false;
                    }
                    $command = 'crontab ' . $cron_file;
                    $output = $return = null;
                    exec($command, $output, $return);
                    if ($return) 
                    {
                        rfpge_log_to_file('An error occured while trying to set cron instead of wp_cron. Status: ' . print_r($return, true) . ' output: ' . print_r($output, true));
                        return false;
                    }
                }
            } else {
                rfpge_log_to_file('An error occured while listing cron jobs. Status: ' . print_r($return, true) . ' output: ' . print_r($output, true));
                return false;
            }
        }
    }
    return true;
}
function rfpge_delete_system_cron() 
{
    if (!rfpge_check_exec_works()) 
    {
		return false;
	}
    $command_string = '0 * * * * wget -q --user-agent="rfpge_create_system_cron" -O - ' . site_url() . ' >/dev/null 2>&1' . PHP_EOL;
    exec('crontab -l', $output, $return);
    if(count($output) > 0 && in_array($command_string, $output))
    {
        if (!$return) 
        {
            foreach ($output as $key => $line) 
            {
                if ($line == $command_string) 
                {
                    unset($output[$key]);
                }
            }
        }
        else
        {
            rfpge_log_to_file('An error occured while listing cron jobs in cron delete. Status: ' . print_r($return, true) . ' output: ' . print_r($output, true));
            return false;
        }
        $output = implode(PHP_EOL, $output);
        if(empty($output))
        {
            $output = $return = null;
            exec("crontab -r", $output, $return);
            if ($return) 
            {
                rfpge_log_to_file('An error occured while trying to delete all wp_cron. Status: ' . print_r($return, true) . ' output: ' . print_r($output, true));
                return false;
            }
            return true;
        }
        $cron_file = dirname(__FILE__) . "/res/rfpge_cron_file.txt";
        $rez = file_put_contents($cron_file, $output);
        if($rez === false)
        {
            rfpge_log_to_file('Failed to put file contents to cron file in delete.');
            return false;
        }
        $output = $return = null;
        exec("crontab " . $cron_file, $output, $return);
        if ($return) 
        {
            rfpge_log_to_file('An error occured while trying to delete wp_cron. Status: ' . print_r($return, true) . ' output: ' . print_r($output, true));
            return false;
        }
    }
}
function rfpge_redirect($url, $statusCode = 301)
{
   header('Location: ' . $url, true, $statusCode);
   die();
}
add_action('admin_init', 'rfpge_register_mysettings');
function rfpge_register_mysettings()
{
    if( isset($_GET['settings-updated']) )
    {
        $echo_Main_Settings = get_option('echo_Main_Settings', false);
        if (isset($echo_Main_Settings['rfpge_enabled']) && $echo_Main_Settings['rfpge_enabled'] == 'on') {
            if (isset($echo_Main_Settings['replace_cron']) && $echo_Main_Settings['replace_cron'] == 'on') {
                rfpge_create_system_cron();
            }
            else
            {
                rfpge_delete_system_cron();
            }
        }
    }
    
    if(isset($_GET['rfpge_page']) && is_numeric($_GET['rfpge_page']))
    {
        $curent_page = $_GET["rfpge_page"];
    }
    else
    {
        $curent_page = '';
    }
    $all_rules = get_option('echo_rules_list', array());
    $rules_count = count($all_rules);
    $rules_per_page = get_option('rfpge_posts_per_page', 16);
    $max_pages = ceil($rules_count/$rules_per_page);
    if($max_pages == 0)
    {
        $max_pages = 1;
    }
    $last_url = (rfpge_isSecure() ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
    if(stristr($last_url, 'rfpge_items_panel') !== false && (!is_numeric($curent_page) || $curent_page > $max_pages || $curent_page <= 0))
    {
        if(stristr($last_url, 'rfpge_page=') === false)
        {
            if(stristr($last_url, '?') === false)
            {
                $last_url .= '?rfpge_page=' . $max_pages;
            }
            else
            {
                $last_url .= '&rfpge_page=' . $max_pages;
            }
        }
        else
        {
            if(isset($_GET['rfpge_page']) && is_numeric($_GET['rfpge_page']))
            {
                $curent_page = $_GET["rfpge_page"];
            }
            else
            {
                $curent_page = '';
            }
            if(is_numeric($curent_page))
            {
                $last_url = str_replace('rfpge_page=' . $curent_page, 'rfpge_page=' . $max_pages, $last_url);
            }
            else
            {
                if(stristr($last_url, '?') === false)
                {
                    $last_url .= '?rfpge_page=' . $max_pages;
                }
                else
                {
                    $last_url .= '&rfpge_page=' . $max_pages;
                }
            }
        }
        rfpge_redirect($last_url);
    }
    if (!get_option('echo_rules_list')) {
        $rules = array();
    } else {
        $rules = get_option('echo_rules_list');
    }
    /*if(count($rules) > 22)
    {
        $htaccess = ABSPATH . '.htaccess';
        if (file_exists($htaccess)) 
        {
            $text2 = file_get_contents($htaccess);
            if($text2 !== FALSE)
            {
                if(stristr($text2, 'php_value max_input_vars 50000') === false)
                {
                    if(stristr(rfpge_get_pinfo(), 'mod_php5') !== FALSE)
                    {
                        $text2 = $text2 . PHP_EOL . '<IfModule mod_php5.c>'. PHP_EOL . 'php_value max_input_vars 50000' . PHP_EOL . '</IfModule>';
                        file_put_contents($htaccess, $text2);
                    }
                }
            }
        }
    }*/
    
    register_setting('rfpge_option_group', 'echo_Main_Settings');
    if(is_multisite())
    {
        if (!get_option('echo_Main_Settings'))
        {
            rfpge_activation_callback(TRUE);
        }
    }
}

function rfpge_get_plugin_url()
{
    return plugins_url('', __FILE__);
}

function rfpge_get_file_url($url)
{
    return rfpge_get_plugin_url() . '/' . $url;
}

add_action('admin_enqueue_scripts', 'rfpge_admin_load_files');
function rfpge_admin_load_files()
{
    wp_register_style('echo-browser-style', plugins_url('styles/echo-browser.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('echo-browser-style');
    wp_enqueue_script('jquery');
    wp_enqueue_script('media-upload');
    wp_enqueue_script('thickbox');
    wp_enqueue_style('thickbox');
}

add_action('wp_enqueue_scripts', 'rfpge_wp_load_files');
function rfpge_wp_load_files()
{
    wp_enqueue_style('rfpge_thumbnail_css', plugins_url('styles/echo-thumbnail.css', __FILE__));
}

function rfpge_random_sentence_generator($first = true)
{
    $echo_Main_Settings = get_option('echo_Main_Settings', false);
    if ($first == false) {
        $r_sentences = $echo_Main_Settings['sentence_list2'];
    } else {
        $r_sentences = $echo_Main_Settings['sentence_list'];
    }
    $r_variables = $echo_Main_Settings['variable_list'];
    $r_sentences = trim($r_sentences);
    $r_variables = trim($r_variables, ';');
    $r_variables = trim($r_variables);
    $r_sentences = str_replace("\r\n", "\n", $r_sentences);
    $r_sentences = str_replace("\r", "\n", $r_sentences);
    $r_sentences = explode("\n", $r_sentences);
    $r_variables = str_replace("\r\n", "\n", $r_variables);
    $r_variables = str_replace("\r", "\n", $r_variables);
    $r_variables = explode("\n", $r_variables);
    $r_vars      = array();
    for ($x = 0; $x < count($r_variables); $x++) {
        $var = explode("=>", trim($r_variables[$x]));
        if (isset($var[1])) {
            $key          = strtolower(trim($var[0]));
            $words        = explode(";", trim($var[1]));
            $r_vars[$key] = $words;
        }
    }
    $max_s    = count($r_sentences) - 1;
    $rand_s   = rand(0, $max_s);
    $sentence = $r_sentences[$rand_s];
    $sentence = str_replace(' ,', ',', ucfirst(rfpge_replace_words($sentence, $r_vars)));
    $sentence = str_replace(' .', '.', $sentence);
    $sentence = str_replace(' !', '!', $sentence);
    $sentence = str_replace(' ?', '?', $sentence);
    $sentence = trim($sentence);
    return $sentence;
}

function rfpge_get_word($key, $r_vars)
{
    if (isset($r_vars[$key])) {
        
        $words  = $r_vars[$key];
        $w_max  = count($words) - 1;
        $w_rand = rand(0, $w_max);
        return rfpge_replace_words(trim($words[$w_rand]), $r_vars);
    } else {
        return "";
    }
    
}

function rfpge_replace_words($sentence, $r_vars)
{
    
    if (str_replace('%', '', $sentence) == $sentence)
        return $sentence;
    
    $words = explode(" ", $sentence);
    
    $new_sentence = array();
    for ($w = 0; $w < count($words); $w++) {
        
        $word = trim($words[$w]);
        
        if ($word != '') {
            if (preg_match('/^%(.*)$/', $word, $m)) {
                $varkey         = trim($m[1]);
                $new_sentence[] = rfpge_get_word($varkey, $r_vars);
            } else {
                $new_sentence[] = $word;
            }
        }
    }
    return implode(" ", $new_sentence);
}

class Echo_keywords{ 
    public static $charset = 'UTF-8';
    public static $banned_words = array('adsbygoogle', 'able', 'about', 'above', 'act', 'add', 'afraid', 'after', 'again', 'against', 'age', 'ago', 'agree', 'all', 'almost', 'alone', 'along', 'already', 'also', 'although', 'always', 'am', 'amount', 'an', 'and', 'anger', 'angry', 'animal', 'another', 'answer', 'any', 'appear', 'apple', 'are', 'arrive', 'arm', 'arms', 'around', 'arrive', 'as', 'ask', 'at', 'attempt', 'aunt', 'away', 'back', 'bad', 'bag', 'bay', 'be', 'became', 'because', 'become', 'been', 'before', 'began', 'begin', 'behind', 'being', 'bell', 'belong', 'below', 'beside', 'best', 'better', 'between', 'beyond', 'big', 'body', 'bone', 'born', 'borrow', 'both', 'bottom', 'box', 'boy', 'break', 'bring', 'brought', 'bug', 'built', 'busy', 'but', 'buy', 'by', 'call', 'came', 'can', 'cause', 'choose', 'close', 'close', 'consider', 'come', 'consider', 'considerable', 'contain', 'continue', 'could', 'cry', 'cut', 'dare', 'dark', 'deal', 'dear', 'decide', 'deep', 'did', 'die', 'do', 'does', 'dog', 'done', 'doubt', 'down', 'during', 'each', 'ear', 'early', 'eat', 'effort', 'either', 'else', 'end', 'enjoy', 'enough', 'enter', 'even', 'ever', 'every', 'except', 'expect', 'explain', 'fail', 'fall', 'far', 'fat', 'favor', 'fear', 'feel', 'feet', 'fell', 'felt', 'few', 'fill', 'find', 'fit', 'fly', 'follow', 'for', 'forever', 'forget', 'from', 'front', 'gave', 'get', 'gives', 'goes', 'gone', 'good', 'got', 'gray', 'great', 'green', 'grew', 'grow', 'guess', 'had', 'half', 'hang', 'happen', 'has', 'hat', 'have', 'he', 'hear', 'heard', 'held', 'hello', 'help', 'her', 'here', 'hers', 'high', 'hill', 'him', 'his', 'hit', 'hold', 'hot', 'how', 'however', 'I', 'if', 'ill', 'in', 'indeed', 'instead', 'into', 'iron', 'is', 'it', 'its', 'just', 'keep', 'kept', 'knew', 'know', 'known', 'late', 'least', 'led', 'left', 'lend', 'less', 'let', 'like', 'likely', 'likr', 'lone', 'long', 'look', 'lot', 'make', 'many', 'may', 'me', 'mean', 'met', 'might', 'mile', 'mine', 'moon', 'more', 'most', 'move', 'much', 'must', 'my', 'near', 'nearly', 'necessary', 'neither', 'never', 'next', 'no', 'none', 'nor', 'not', 'note', 'nothing', 'now', 'number', 'of', 'off', 'often', 'oh', 'on', 'once', 'only', 'or', 'other', 'ought', 'our', 'out', 'please', 'prepare', 'probable', 'pull', 'pure', 'push', 'put', 'raise', 'ran', 'rather', 'reach', 'realize', 'reply', 'require', 'rest', 'run', 'said', 'same', 'sat', 'saw', 'say', 'see', 'seem', 'seen', 'self', 'sell', 'sent', 'separate', 'set', 'shall', 'she', 'should', 'side', 'sign', 'since', 'so', 'sold', 'some', 'soon', 'sorry', 'stay', 'step', 'stick', 'still', 'stood', 'such', 'sudden', 'suppose', 'take', 'taken', 'talk', 'tall', 'tell', 'ten', 'than', 'thank', 'that', 'the', 'their', 'them', 'then', 'there', 'therefore', 'these', 'they', 'this', 'those', 'though', 'through', 'till', 'to', 'today', 'told', 'tomorrow', 'too', 'took', 'tore', 'tought', 'toward', 'tried', 'tries', 'trust', 'try', 'turn', 'two', 'under', 'until', 'up', 'upon', 'us', 'use', 'usual', 'various', 'verb', 'very', 'visit', 'want', 'was', 'we', 'well', 'went', 'were', 'what', 'when', 'where', 'whether', 'which', 'while', 'white', 'who', 'whom', 'whose', 'why', 'will', 'with', 'within', 'without', 'would', 'yes', 'yet', 'you', 'young', 'your', 'br', 'img', 'p','lt', 'gt', 'quot', 'copy');
    public static $min_word_length = 4;
    
    public static function text($text, $length = 160)
    {
        return self::limit_chars(self::clean($text), $length,'',TRUE);
    } 

    public static function keywords($text, $max_keys = 3)
    {
        $wordcount = array_count_values(str_word_count(self::clean($text),1));
        foreach ($wordcount as $key => $value) 
        {
            if ( (strlen($key)<= self::$min_word_length) OR in_array($key, self::$banned_words))
                unset($wordcount[$key]);
        }
        uasort($wordcount,array('self','cmp'));
        $wordcount = array_slice($wordcount,0, $max_keys);
        return implode(' ', array_keys($wordcount));
    } 

    private static function clean($text)
    { 
        $text = html_entity_decode($text,ENT_QUOTES,self::$charset);
        $text = strip_tags($text);
        $text = preg_replace('/\s\s+/', ' ', $text);
        $text = str_replace (array('\r\n', '\n', '+'), ',', $text);
        return trim($text); 
    } 

    private static function cmp($a, $b) 
    {
        if ($a == $b) return 0; 

        return ($a < $b) ? 1 : -1; 
    } 

    private static function limit_chars($str, $limit = 100, $end_char = NULL, $preserve_words = FALSE)
    {
        $end_char = ($end_char === NULL) ? 'Ã¢â‚¬Â¦' : $end_char;
        $limit = (int) $limit;
        if (trim($str) === '' OR strlen($str) <= $limit)
            return $str;
        if ($limit <= 0)
            return $end_char;
        if ($preserve_words === FALSE)
            return rtrim(substr($str, 0, $limit)).$end_char;
        if ( ! preg_match('/^.{0,'.$limit.'}\s/us', $str, $matches))
            return $end_char;
        return rtrim($matches[0]).((strlen($matches[0]) === strlen($str)) ? '' : $end_char);
    }
} 
require(dirname(__FILE__) . "/res/echo-main.php");
require(dirname(__FILE__) . "/res/echo-rules-list.php");
require(dirname(__FILE__) . "/res/echo-rss.php");
require(dirname(__FILE__) . "/res/echo-logs.php");
require(dirname(__FILE__) . "/res/echo-helper.php");
?>